@echo off

REM Licensed Materials - Property of IBM
REM IBM Cognos Products: XQE
REM (C) Copyright IBM Corp. 2009, 2010
REM US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

setlocal

CD %~dp0

if "%1" == "1" goto findJava
if "%1" == "2" goto findJava
if "%1" == "3" goto finish
if "%1" == "4" goto finish
if "%1" == "-help" goto help


echo.
echo ERROR Encountered!! Invalid input value passed to utility QueryServiceAdminTask. For help use command [ queryServiceAdminTask.bat -help ] .
goto finish

:findJava
set J_HOME=jre\6.0
echo Looking for JRE in: %J_HOME%\bin...
if exist "%J_HOME%\bin\java.exe" goto gotJava

rem JAVA_HOME should be defined first.
if "%JAVA_HOME%" == "" goto JavaHomeError
set J_HOME=%JAVA_HOME%
echo Looking for JRE in: %J_HOME%\bin...
if exist "%J_HOME%\bin\java.exe" goto gotJava
set J_HOME=%JAVA_HOME%\jre
echo Looking for JRE in: %J_HOME%\jre\bin...
if exist "%J_HOME%\bin\java.exe" goto gotJava


:help
echo.
echo Use the QueryServiceAdminTask to specify query service operations. This utility expects two input parameters:  TaskType(String Input) and TaskParameter(String Input).
echo.
echo The first (mandatory) parameter, TaskType(String Input), identifies the type of operation. Use one of the following values. For TaskType 2, a file called SALDump.xml is created in the "<c10_location>/logs/XQE" folder.
echo.
echo.
echo ------------------------------------------------------------------------
echo 1 - Clear Secure Cache.
echo 2 - Write Secure Cache State.
echo ------------------------------------------------------------------------
echo.
echo.
echo The second (optional) parameter, TaskParameter(String Input), identifies the values used to perform the operation specified by the first parameter. 
echo.
echo Use the format, "<datasource_name>/<catalog_name>/<cube_name>". You can use the wild card character "*" for any datasource, catalog, or cube name. For example, "*/*/*" or "DS_TEMP/*/*". When no input is used for this parameter, it uses the value "*/*/*" by default.
echo.
echo In this example, [ queryServiceAdminTask.bat 1 "*/*/*" ] the secured cache is cleared for all cubes in all catalogs under all datasources.
goto finish



:JavaHomeError
echo Could not find path to java.
echo The environment variable JAVA_HOME is not defined or incorrectly defined.
echo Please define JAVA_HOME first.
goto finish



:gotJava
set emptyStr = ""
set J_OPTS=-Dlog4j.configuration=%emptyStr%
set _RUNJAVA="%J_HOME%\bin\java"
set CP=..\webapps\p2pd\WEB-INF\classes;..\webapps\p2pd\WEB-INF\lib\cclcfgapi.jar;..\webapps\p2pd\WEB-INF\lib\jcam_crypto.jar;..\webapps\p2pd\WEB-INF\lib\CognosIPF.jar;..\webapps\p2pd\WEB-INF\lib\log4j-1.2.8.jar;..\tomcat\lib\jcam_jni.jar;..\webapps\p2pd\WEB-INF\lib\xqeService.jar;..\webapps\p2pd\WEB-INF\lib\hessian-3.0.8.jar;..\webapps\p2pd\WEB-INF\lib\mx4j-tools.jar;..\webapps\p2pd\WEB-INF\lib\CognosCCL4J.jar;..\webapps\p2pd\WEB-INF\lib\commons-lang-2.3.jar;..\webapps\p2pd\WEB-INF\lib\commons-configuration-1.5.jar;..\webapps\p2pd\WEB-INF\lib\commons-logging-1.1.jar;..\webapps\p2pd\WEB-INF\lib\commons-collections-3.2.1.jar

@echo Using CLASSPATH: %CP%
@echo Using J_HOME:    %J_HOME%
@echo Using J_OPTS:   %J_OPTS%

%_RUNJAVA% -cp %CP% %J_OPTS% com.cognos.xqe.adminconsole.commandlineutility.QueryServiceAdminTask %1 %2
goto finish

:finish
endlocal
