<?xml version="1.0" encoding="UTF-8"?>
<!--
+=========================================================================+
| Licensed Materials - Property of IBM                                    |
| BI and PM: viewer                                                         |
| (C) Copyright IBM Corp. 2002, 2010                                      |
|                                                                         |
| US Government Users Restricted Rights - Use, duplication or             |
| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.       |
|                                                                         |
+=========================================================================+
-->
<stylesheet version="1.0" xmlns="http://www.w3.org/1999/XSL/Transform">
	<output method="text" encoding="UTF-8"/>
	<template match="/">
		<text>/*&#x0a;</text>
		<text> *+=========================================================================+&#x0a;</text>
		<text> *| IBM Confidential                                                        |&#x0a;</text>
		<text> *| Licensed Materials - Property of IBM                                    |&#x0a;</text>
		<text> *| BI and PM: viewer                                                         |&#x0a;</text>
		<text> *| (C) Copyright IBM Corp. 2002, 2010                                      |&#x0a;</text>
		<text> *|                                                                         |&#x0a;</text>
		<text> *| US Government Users Restricted Rights - Use, duplication or             |&#x0a;</text>
		<text> *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.       |&#x0a;</text>
		<text> *|                                                                         |&#x0a;</text>
		<text> *+=========================================================================+&#x0a;</text>
		<text>*/&#x0a;</text>
		<for-each select="stringTable/component">
			<variable name="comp_name" select="@name"/>
			<variable name="comp_name_res">
				<value-of select="$comp_name"/>_RES</variable>
			<text>var </text>
			<value-of select="$comp_name_res"/>
			<text> = {};&#x0a;</text>
			<for-each select="section">
				<variable name="sect_name" select="@name"/>
				<if test="$sect_name != 'STC' and $sect_name != 'DFP' and $sect_name != 'CON'">
					<for-each select="string">
						<!-- Generate the name of the member COMPONENT_NAME_RES.ID, RV_RES.ids....-->
						<value-of select="$comp_name_res"/>
						<text>.</text>
						<value-of select="@id"/>
						<text> =  &quot;</text>
						<!-- generate the message text based on rule #3 and #4 -->
						<variable name="msgstring">
							<for-each select="child::node()">
								<choose>
									<when test="name() = 'param'">
										<choose>
											<when test="@name">
												<text disable-output-escaping="yes">{</text>
												<value-of select="@name"/>
												<text disable-output-escaping="yes">}</text>
											</when>
											<when test="@index">
												<text disable-output-escaping="yes">{</text>
												<value-of select="@index - 1"/>
												<text disable-output-escaping="yes">}</text>
											</when>
											<otherwise>
												<message terminate="yes">Parameter Substitution Error: Missing name or index.</message>
											</otherwise>
										</choose>
									</when>
									<when test="name() = ''">
										<value-of select="."/>
									</when>
									<otherwise>
										<copy>
											<copy-of select="@*"/>
										</copy>
									</otherwise>
								</choose>
							</for-each>
						</variable>
						<choose>
							<when test="@whiteSpace and @whiteSpace='preserve'">
								<text disable-output-escaping="yes">\</text>
								<value-of select="$msgstring"/>
							</when>
							<otherwise>
								<call-template name="escapeDoubleQuotes">
									<with-param name="string"><value-of select="normalize-space($msgstring)"/></with-param>
								</call-template>		
								<!-- value-of select="normalize-space($msgstring)"/ -->
							</otherwise>
						</choose>
						<text>&quot;;&#x0a;</text>
					</for-each>
				</if>
			</for-each>
		</for-each>
	</template>

	<template name="replaceChar">
		<param name="text"/>
		<param name="toReplace"/>
		<param name="replaceWith"/>
		<choose>
			<when test="contains($text, $toReplace)">
				<variable name="beforeChar" select="substring-before($text,$toReplace)"/>
				<variable name="afterChar">
					<call-template name="replaceChar">
						<with-param name="text" select="substring-after($text,$toReplace)"/>
						<with-param name="toReplace" select="$toReplace"/>
						<with-param name="replaceWith" select="$replaceWith"/>
					</call-template>
				</variable>
				<value-of select="concat($beforeChar, $replaceWith, $afterChar)"/>
			</when>
			<otherwise>
				<value-of select="$text"/>
			</otherwise>
		</choose>
	</template>
	<!-- copy everything by default -->
	<template name="copyAll" match="*">
		<copy>
			<copy-of select="@*"/>
			<apply-templates/>
		</copy>
	</template>

	<template name="escapeDoubleQuotes">
		<param name="string" select="''"/>
		<choose>
			<when test="contains($string, '&quot;')">
				<text/>
				<value-of select="substring-before($string, '&quot;')"/>\"<call-template name="escapeDoubleQuotes">
					<with-param name="string" select="substring-after($string, '&quot;')"/>
				</call-template>
				<text/>
			</when>
			<otherwise>
				<text/>
				<value-of select="$string"/>
				<text/>
			</otherwise>
		</choose>
	</template>
	
</stylesheet>
