<?xml version="1.0" encoding="UTF-8"?>
<!--
  Licensed Materials - Property of IBM
  IBM Cognos Products: Viewer
  (C) Copyright IBM Corp. 2001, 2010

  US Government Users Restricted Rights - Use, duplication or
  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:rvl="http://developer.cognos.com/schemas/xts/logicsheets/xslt/presentation/rv/rvlogic/"
	xmlns:out="dummy-uri"
	xmlns:xtsext="xalan://com.cognos.xts.ext.XTSExt"
	xmlns:xts="http://developer.cognos.com/schemas/xts/"
	exclude-result-prefixes="xsl rvl xtsext xts">

	<xsl:output method="xml" encoding="UTF-8" indent="no"/>
	<xsl:namespace-alias stylesheet-prefix="out" result-prefix="xsl"/>

	<xsl:template match="rvl:drillThruForm">
		<!-- drill thru form -->
		<form name="stackForm" id="stackForm" method="post" style="margin:0px">

			<out:variable name="stack-idx">
				<out:value-of select="count( /root/env/param[ starts-with( @name, 'rvstack_' ) ] )"/>
			</out:variable>
			<out:variable name="stack-name" select="concat( 'rvstack_', $stack-idx )"/>

			<out:if test="$status = 'complete'">
				<input type="hidden">
					<out:attribute name="name"><out:value-of select="$stack-name"/></out:attribute>
					<out:attribute name="value">
						<out:variable name="envParams">
							<out:choose>
								<out:when test="/root/env/param[@name='ui.action']='view'">
									<out:text>&lt;param name="ui.action"&gt;view&lt;/param&gt;</out:text>
								</out:when>
								<out:otherwise>
									<out:text>&lt;param name="ui.action"&gt;currentPage&lt;/param&gt;</out:text>
									<out:text>&lt;param name="ui.conversation"&gt;</out:text>
									<out:variable name="markup-conv">
										<out:call-template name="serialize-xml">
											<out:with-param name="node-set" select="$conversation"/>
										</out:call-template>
									</out:variable>
									<out:value-of select="xtsext:cafaction(concat('sign_wrap_setpassportid_', $passport), xtsext:web64encode(string($markup-conv), true()))"/>
									<out:text>&lt;/param&gt;</out:text>
									<out:text>&lt;param name="m_tracking"&gt;</out:text>
									<out:variable name="markup-tracking">
										<out:call-template name="serialize-xml">
											<out:with-param name="node-set" select="/root/response/SOAP-ENV:Envelope/SOAP-ENV:Header/bus:biBusHeader/bus:tracking/*[local-name() = 'conversationContext']"/>
										</out:call-template>
									</out:variable>
									<out:value-of select="xtsext:cafaction(concat('sign_wrap_setpassportid_', $passport), xtsext:web64encode(string($markup-tracking), true()))"/>
									<out:text>&lt;/param&gt;</out:text>
								</out:otherwise>
							</out:choose>
							<out:for-each select="/root/env/*[@name='ui.name' or @name='ui.format' or @name='ui.object' or @name='session_prompts' or @name='run.outputFormat' or @name='ui.spec']">
								<out:call-template name="serialize-xml">
									<out:with-param name="node-set" select="."/>
								</out:call-template>
							</out:for-each>
						</out:variable>
						<out:variable name="markup">
							<out:choose>
								<out:when test="$reportName != ''">reportName = '<out:value-of select="xtsext:javascriptencode(string($reportName))"/>';</out:when>
								<out:otherwise>reportName = '<xts:string id="RV_PREVIOUS_REPORT" encode="javascript"/>';</out:otherwise>
							</out:choose>
							stackIdx = '<out:value-of select="xtsext:javascriptencode(string($stack-idx))"/>';
							envParams='<out:value-of select="xtsext:javascriptencode(string($envParams))"/>';
						</out:variable>
						<out:value-of select="xtsext:cafaction(concat('sign_wrap_setpassportid_', $passport), xtsext:web64encode( string( $markup ), true()))"/>
					</out:attribute>
				</input>
			</out:if>
		</form>
	</xsl:template>

	<xsl:template match="rvl:selectChoices">
		<out:choose>
			<!--when selectChoices element is passed through, it's has already been xml encoded, so don't double encode it -->
			<out:when test="starts-with(normalize-space(string(./@value)), '&lt;selectChoices&gt;')">
				<out:value-of select="string(./@value)"/>
			</out:when>
			<out:otherwise>
				<out:if test="./@value!=''">
					<out:text>&lt;selectChoices&gt;</out:text>
					<out:text>&lt;selectOption </out:text>
					<out:text>useValue=&quot;</out:text>
					<out:choose>
						<out:when test="./@mun != ''"><out:value-of select="xtsext:xmlencode(string(./@mun))"/></out:when>
						<out:otherwise><out:value-of select="xtsext:xmlencode(string(./@value))"/></out:otherwise>
					</out:choose>
					<out:text>&quot; </out:text>

					<out:variable name="name" select="./@name"/>
					<out:variable name="drillTargetLabel" select="../@label"/>
					<out:text>propertyToPass=&quot;</out:text>
					<out:choose>
						<out:when test="string(./@propertyToPass) != ''">
							<out:value-of select="./@propertyToPass"/>
						</out:when>
						<out:when test="/root/drillSpecs/DRILLS/DRILL[@label = string($drillTargetLabel)]/PARAMETER-PROPERTIES/Parameter[@name=string($name)]/@propertyToPass != ''">
							<out:value-of select="xtsext:xmlencode(string(/root/drillSpecs/DRILLS/DRILL[@label = string($drillTargetLabel)]/PARAMETER-PROPERTIES/Parameter[@name=string($name)]/@propertyToPass))"/>
						</out:when>
					</out:choose>
					<out:text>&quot; </out:text>

					<out:text>displayValue=&quot;</out:text>
					<out:choose>
						<out:when test="./@mun"><out:value-of select="xtsext:xmlencode(string(./@value))"/></out:when>
						<out:when test="./@displayValue"><out:value-of select="xtsext:xmlencode(string(./@displayValue))"/></out:when>
						<out:otherwise><out:value-of select="xtsext:xmlencode(string(./@value))"/></out:otherwise>
					</out:choose>
					<out:text>&quot;</out:text>
					<out:if test="./@mun">
						<out:text> mun=&quot;</out:text><out:value-of select="xtsext:xmlencode(string(./@mun))"/><out:text>&quot;</out:text>
					</out:if>
					<out:text>/&gt;</out:text>
					<out:text>&lt;/selectChoices&gt;</out:text>
				</out:if>
			</out:otherwise>
		</out:choose>
	</xsl:template>

	<xsl:template match="rvl:selectChoicesNil">
		<out:text>&lt;selectChoices/&gt;</out:text>
	</xsl:template>

	<!-- the main engine -->
	<xsl:template match="*">
		<xsl:copy>
			<xsl:copy-of select="@*"/>
			<xsl:apply-templates/>
		</xsl:copy>
	</xsl:template>

</xsl:stylesheet>