<?xml version="1.0" encoding="UTF-8"?>
<!--
Licensed Materials - Property of IBM

IBM Cognos Products: rsvp

(C) Copyright IBM Corp. 2005, 2010

US Government Users Restricted Rights - Use, duplication or disclosure 
restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<!-- COPYRIGHT_DATA {'RELEASE': ['2005', '2009', 'colorado_wave1', 'colorado_wave2'], 'VISIBLE': 'YES', 'COMPONENT': 'rsvp'}-->
<!--All lines above the COPYRIGHT_DATA  line will be replaced when copyright notices are generated. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:rsext="xalan://com.cognos.reportserver.ext.RSExt" version="1.0" exclude-result-prefixes="rsext">
	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="no"/>
	<xsl:param name="namespaceId" select="''"/>	
	<xsl:param name="CVGateway" select="''"/>
	<xsl:variable name="vUseStyleId">
		<xsl:choose>
			<xsl:when test="$email='yes'">false</xsl:when>
			<xsl:when test="not(/Document/styleOptions/cssOptStyle)">false</xsl:when>
			<xsl:otherwise>true</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	 <xsl:key name="getOptStyle" match="cssOptStyle" use="@styleId"/>
	<xsl:template name="GenCommonAttributes">
		<xsl:variable name="sBackgroundImage">
			<xsl:if test="@bgsrc or @bgsrcemail">
				<xsl:choose>
					<xsl:when test="$chartSrc = 'src'">
						<xsl:text disable-output-escaping="yes">background-image:url(</xsl:text>
						<xsl:value-of select="@bgsrc"/>
						<xsl:text disable-output-escaping="yes">);</xsl:text>
					</xsl:when>
					<xsl:when test="$chartSrc = 'srcemail'">
						<xsl:text disable-output-escaping="yes">background-image:url(</xsl:text>
						<xsl:value-of select="@bgsrcemail"/>
						<xsl:text disable-output-escaping="yes">);</xsl:text>
					</xsl:when>
				</xsl:choose>
			</xsl:if>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="@style">
				<!-- Add cursor to style if bookmarkRef defined -->
				<xsl:attribute name="style"><xsl:for-each select="@style"><xsl:value-of select="."/>;</xsl:for-each><!-- Use pointer and hand (in that order) to get NS and IE working --><xsl:if test="@bookmarkRef">cursor:pointer;cursor:hand;</xsl:if><xsl:value-of select="$sBackgroundImage"/></xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<!-- no style, check for bookmarkRef.  This avoids generating two style attributes -->
				<xsl:choose>
					<xsl:when test="@bookmarkRef">
						<xsl:attribute name="style"><xsl:text>cursor:pointer;cursor:hand;</xsl:text><xsl:value-of select="$sBackgroundImage"/></xsl:attribute>
					</xsl:when>
					<xsl:when test="string-length ($sBackgroundImage) > 0">
						<xsl:attribute name="style"><xsl:value-of select="$sBackgroundImage"/></xsl:attribute>
					</xsl:when>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="@bookmarkRef">
			<xsl:choose>
				<xsl:when test="$mht='true'">
					<xsl:choose>
						<xsl:when test="$strict = 'true'">
					<xsl:attribute name="onclick">docLocation('<xsl:value-of select="@bookmarkRef"/>');</xsl:attribute>
					<xsl:attribute name="onkeypress">if (event.keyCode == 13) { docLocation('<xsl:value-of select="@bookmarkRef"/>'); }</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="onClick">docLocation('<xsl:value-of select="@bookmarkRef"/>');</xsl:attribute>
							<xsl:attribute name="onKeyPress">if (event.keyCode == 13) { docLocation('<xsl:value-of select="@bookmarkRef"/>'); }</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:if test="$accessible='true'">
								<xsl:attribute name="role">link</xsl:attribute>
							</xsl:if>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$strict = 'true'">
					<xsl:attribute name="onclick">document.location='#<xsl:value-of select="@bookmarkRef"/>';</xsl:attribute>
					<xsl:attribute name="onkeypress">if (event.keyCode == 13) { document.location='#<xsl:value-of select="@bookmarkRef"/>'; }</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="onClick">document.location='#<xsl:value-of select="@bookmarkRef"/>';</xsl:attribute>
							<xsl:attribute name="onKeyPress">if (event.keyCode == 13) { document.location='#<xsl:value-of select="@bookmarkRef"/>'; }</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:if test="$accessible='true'">
								<xsl:attribute name="role">link</xsl:attribute>
							</xsl:if>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="not(@class) and @styleId and @layoutClass">
				<xsl:choose>
					<xsl:when test="$vUseStyleId='true'">
						<xsl:attribute name="class"><xsl:value-of select="@layoutClass"/><xsl:text> </xsl:text><xsl:value-of select="@styleId"/></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="style"><xsl:value-of select="key('getOptStyle',@styleId)/@value"/></xsl:attribute>
						<xsl:attribute name="class"><xsl:value-of select="@layoutClass"/></xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>		
			<xsl:when test="not(@class) and not(@styleId) and @layoutClass">
				<xsl:attribute name="class"><xsl:value-of select="@layoutClass"/></xsl:attribute>
			</xsl:when>
			<xsl:when test="@styleId and @class">
				<xsl:choose>
					<xsl:when test="$vUseStyleId='true'">
						<xsl:attribute name="class"><xsl:value-of select="@class"/><xsl:text> </xsl:text><xsl:value-of select="@styleId"/></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="style"><xsl:value-of select="key('getOptStyle',@styleId)/@value"/></xsl:attribute>
						<xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="not(@styleId) and @class">
			<xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
			</xsl:when>
			<xsl:when test="not(@class) and not(@layoutClass) and @styleId">
				<xsl:choose>
					<xsl:when test="$vUseStyleId='true'">
						<xsl:attribute name="class"><xsl:value-of select="@styleId"/></xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="style"><xsl:value-of select="key('getOptStyle',@styleId)/@value"/></xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>				
		</xsl:choose>

		<xsl:if test="@tooltip">
			<xsl:attribute name="title"><xsl:value-of select="@tooltip"/></xsl:attribute>
		</xsl:if>
		<xsl:if test="$strict='false'">
			<xsl:for-each select="./HA/@*">
				<xsl:attribute name="{local-name()}"><xsl:value-of select="."/></xsl:attribute>
			</xsl:for-each>
			<xsl:for-each select="@name">
				<xsl:attribute name="LID"><xsl:value-of select="."/><xsl:value-of select="$namespaceId"/></xsl:attribute>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="GenRTAttributes">
		<xsl:choose>
			<xsl:when test="@style">
				<!-- Add cursor to style if bookmarkRef defined -->
				<xsl:attribute name="style"><xsl:for-each select="@style"><xsl:value-of select="."/>;</xsl:for-each><!-- Use pointer and hand (in that order) to get NS and IE working --><xsl:if test="@bookmarkRef">cursor:pointer;cursor:hand;</xsl:if></xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<!-- no style, check for bookmarkRef.  This avoids generating two style attributes -->
				<xsl:if test="@bookmarkRef">
					<xsl:attribute name="style">cursor:pointer;cursor:hand;</xsl:attribute>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="@bookmarkRef">
			<xsl:choose>
				<xsl:when test="$mht='true'">
					<xsl:choose>
						<xsl:when test="$strict='true'">
					<xsl:attribute name="onclick">docLocation('<xsl:value-of select="@bookmarkRef"/>');</xsl:attribute>
					<xsl:attribute name="onkeypress">if (event.keyCode == 13) { docLocation('<xsl:value-of select="@bookmarkRef"/>'); }</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="onClick">docLocation('<xsl:value-of select="@bookmarkRef"/>');</xsl:attribute>
							<xsl:attribute name="onKeyPress">if (event.keyCode == 13) { docLocation('<xsl:value-of select="@bookmarkRef"/>'); }</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:if test="$accessible='true'">
								<xsl:attribute name="role">link</xsl:attribute>
							</xsl:if>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="$strict='true'">
					<xsl:attribute name="onclick">document.location='#<xsl:value-of select="@bookmarkRef"/>';</xsl:attribute>
					<xsl:attribute name="onkeypress">if (event.keyCode == 13) { document.location='#<xsl:value-of select="@bookmarkRef"/>'; }</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="onClick">document.location='#<xsl:value-of select="@bookmarkRef"/>';</xsl:attribute>
							<xsl:attribute name="onKeyPress">if (event.keyCode == 13) { document.location='#<xsl:value-of select="@bookmarkRef"/>'; }</xsl:attribute>
							<xsl:attribute name="tabIndex">0</xsl:attribute>
							<xsl:if test="$accessible='true'">
								<xsl:attribute name="role">link</xsl:attribute>
							</xsl:if>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<xsl:if test="@class">
			<xsl:attribute name="class"><xsl:value-of select="@class"/></xsl:attribute>
		</xsl:if> 
		<!--<xsl:if test="not(@class) and @layoutClass">
			<xsl:attribute name="class"><xsl:value-of select="@layoutClass"/></xsl:attribute>
		</xsl:if>-->
		<xsl:if test="@styleId">
			<xsl:choose>
				<xsl:when test="$vUseStyleId='true'">
					<xsl:attribute name="class"><xsl:value-of select="@styleId"/></xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="style"><xsl:value-of select="key('getOptStyle',@styleId)/@value"/></xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>				
		<xsl:if test="@tooltip">
			<xsl:attribute name="title"><xsl:value-of select="@tooltip" /></xsl:attribute>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="GenTDAttributes">
		<xsl:call-template name="GenCommonAttributes"/>
		<xsl:if test="@colspan">
			<xsl:attribute name="colspan"><xsl:value-of select="@colspan" /></xsl:attribute>
		</xsl:if>
		<xsl:if test="@rowspan">
			<xsl:attribute name="rowspan"><xsl:value-of select="@rowspan" /></xsl:attribute>
		</xsl:if>
		<xsl:if test="$strict='true' or $accessible='true'"> <!-- Accessibility only -->
			<xsl:variable name="viewerID">
				<xsl:choose>
					<xsl:when test="string($CognosViewerID)=''"><xsl:value-of select="'_THIS_'"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="$CognosViewerID"/></xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:if test="@id">
				<xsl:attribute name="id">
					<xsl:choose>
						<xsl:when test="starts-with(@id, 'hdr')"><xsl:value-of select="concat($viewerID, @id)"/></xsl:when>
						<xsl:otherwise><xsl:value-of select="@id"/></xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>
			</xsl:if>	
			<xsl:if test="@headers">
				<xsl:attribute name="headers"><xsl:value-of select='rsext:replace(@headers, "hdr", concat($viewerID, "hdr"))'/></xsl:attribute>
			</xsl:if>	
			<xsl:if test="@axis">
				<xsl:attribute name="axis"><xsl:value-of select="@axis" /></xsl:attribute>
			</xsl:if>	
			<xsl:if test="@layoutClass='crosstabNodeMember' and $strict='false'">
				<xsl:choose>
					<xsl:when test="parent::node()/@isTopLabel">
						<xsl:attribute name="role">columnheader</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="role">rowheader</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</xsl:if>
		<!-- TCB <xsl:if test="@hspan">
			<xsl:attribute name="colspan"><xsl:value-of select="@hspan" /></xsl:attribute>
		</xsl:if>
		<xsl:if test="@vspan">
			<xsl:attribute name="rowspan"><xsl:value-of select="@vspan" /></xsl:attribute>
		</xsl:if> -->
	</xsl:template>
	<xsl:template name="GenTDChildElements">
		<xsl:choose>
			<xsl:when test="count (*) = 0">
				<xsl:choose>
					<xsl:when test="$vUseStyleId='true'">
						<xsl:variable name="sStyleIdValue1" select="key('getOptStyle',@styleId)/@value"/>
						<xsl:variable name="sStyleIdValue2" select="key('getOptStyle',../../@styleId)/@value"/>
						<xsl:if test="contains($sStyleIdValue1,'empty-cells:show') or contains($sStyleIdValue2,'empty-cells:show')">
							<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
				<xsl:if test="contains(@style,'empty-cells:show') or contains(../../@style,'empty-cells:show')">
					<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
				</xsl:if>
					</xsl:otherwise>
				</xsl:choose>				
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates select="*"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="GenCommonTableAttributes">
		<xsl:call-template name="GenCommonAttributes"/>
		<xsl:attribute name="cellpadding"><xsl:text>0</xsl:text></xsl:attribute>
		<xsl:choose>
			<xsl:when test="not(@styleId) and @style">
		<xsl:if test="contains(@style, 'border-spacing:') and $strict='false'">
		<xsl:attribute name="cellspacing"><xsl:variable name="sBorderSpacing" select="substring-after(@style, 'border-spacing:')"/><xsl:choose><xsl:when test="substring-before($sBorderSpacing, ';')"><xsl:value-of select="substring-before($sBorderSpacing, ';')" /></xsl:when><xsl:when test="$sBorderSpacing"><xsl:value-of select="$sBorderSpacing" /></xsl:when><xsl:otherwise><xsl:text >0</xsl:text></xsl:otherwise></xsl:choose></xsl:attribute>
		</xsl:if>
			</xsl:when>
			<xsl:when test="not(@style) and @styleId">
				<xsl:variable name="sStyleIdValue" select="key('getOptStyle',@styleId)/@value"/>
				<xsl:if test="contains($sStyleIdValue, 'border-spacing:') and $strict='false'">
					<xsl:attribute name="cellspacing"><xsl:variable name="sBorderSpacing" select="substring-after($sStyleIdValue, 'border-spacing:')"/><xsl:choose><xsl:when test="substring-before($sBorderSpacing, ';')"><xsl:value-of select="substring-before($sBorderSpacing, ';')"/></xsl:when><xsl:when test="$sBorderSpacing"><xsl:value-of select="$sBorderSpacing"/></xsl:when><xsl:otherwise><xsl:text>0</xsl:text></xsl:otherwise></xsl:choose></xsl:attribute>
				</xsl:if>
			</xsl:when>
		</xsl:choose>
		<xsl:if test="$accessible='true' and @summaryText">
			<xsl:attribute name="summary"><xsl:value-of select="@summaryText" /></xsl:attribute>
		</xsl:if>
	</xsl:template>
	<xsl:template match="styleOptions">
		<xsl:if test="$appSupport='false'">
		<xsl:choose>
			<xsl:when test="$email='true'">
				<xsl:for-each select="cssText">
					<style type="text/css">
						<xsl:value-of select="."/>
					</style>
				</xsl:for-each>
			</xsl:when>
			<xsl:when test="cssOptStyles">
				<xsl:for-each select="cssUrl">
					<link rel="stylesheet" type="text/css">
						<xsl:attribute name="href"><xsl:value-of select="."/></xsl:attribute>
					</link>
				</xsl:for-each>
				<style type="text/css"><xsl:value-of select="cssOptStyles" disable-output-escaping="yes"/></style>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="cssUrl">
					<link rel="stylesheet" type="text/css">
						<xsl:attribute name="href"><xsl:value-of select="."/></xsl:attribute>
					</link>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:if test="namedCssStyleText">
			<style type="text/css">
				<xsl:value-of select="namedCssStyleText" disable-output-escaping="yes"/>
			</style>
		</xsl:if>		
		</xsl:if>
	</xsl:template>
	<!-- Generate a background image in case we are saving the report -->
	<xsl:template name="GenBackgroundImage">
		<xsl:if test="(@bgsrcsave or @bgsrcsaveAs) and ($chartSrc='srcsave' or $chartSrc='srcsaveAs')">
			<xsl:variable name="sBackgroundName">
				<xsl:value-of select='concat ("i", $pageNumber, rsext:replace(string(generate-id(.)), ".", "_"))' />
			</xsl:variable>
			<script>
			<xsl:if test="$strict='false'">
				<xsl:attribute name="language">javascript</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:attribute name="id"><xsl:value-of select="$sBackgroundName" /></xsl:attribute>
			<xsl:if test="$Xhtml='true'">
				<xsl:text disable-output-escaping="yes">
					//&lt;![CDATA[
				</xsl:text>
			</xsl:if>	
			<!-- 
			Create the uri that points to the saved output chart in content manager.
			The variables are defined in html.xsl
			-->
			<xsl:variable name="sGraphicName">
				<xsl:choose>
					<xsl:when test="$chartSrc='srcsaveAs'">
						<xsl:value-of select="@bgsrcsaveAs"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="@bgsrcsave"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			displayBackground("<xsl:value-of select='$sBackgroundName'/>", "<xsl:value-of select="rsext:javascriptencode(string($sGraphicName))"/>", 
			<xsl:choose>
				<xsl:when test="$testMode = 'true'">true</xsl:when>
				<xsl:otherwise>false</xsl:otherwise>
			</xsl:choose>);
			<xsl:if test="$Xhtml='true'">
				<xsl:text disable-output-escaping="yes">
					//]]&gt;
				</xsl:text>
			</xsl:if>
</script>
		</xsl:if>
	</xsl:template>				
	
	<xsl:template name="GenChartImageContainer">
		<xsl:variable name="uniqueId"><xsl:value-of select="concat($CognosViewerID, generate-id(.), $pageNumber)"/></xsl:variable>	
		<span>
			<xsl:if test="$strict ='false'">
				<xsl:attribute name="tabIndex">0</xsl:attribute>
			</xsl:if>
			<xsl:if test="$accessible='true'">
				<xsl:attribute name="role">presentation</xsl:attribute>			
				<xsl:attribute name="aria-labelledby"><xsl:value-of select="$uniqueId"/></xsl:attribute>
				<span style="visibility:hidden; display:none" id="{$uniqueId}"><xsl:value-of select="@altText"/></span>
			</xsl:if>
			<xsl:call-template name="GenChartImage"/>
		</span>		
	</xsl:template>
	
	<!-- Generate a chart image -->
	<xsl:template name="GenChartImage">
		<img>
			<xsl:choose>
				<xsl:when test="$strict='true'">
			<xsl:attribute name="id">chart<xsl:value-of select='concat ($pageNumber, "_", rsext:replace(string(generate-id(.)), ".", "_"))'/></xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
			<xsl:attribute name="name">chart<xsl:value-of select="generate-id(.)"/></xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:call-template name="GenCommonAttributes"/>
			<xsl:call-template name="GenEventHandlers"/>
			<xsl:choose>
				<xsl:when test="$chartSrc = 'src'">
					<xsl:attribute name="src">
						<xsl:choose>
							<xsl:when test="starts-with(@src, '?b_action')">
								<xsl:value-of select="$CVGateway"/><xsl:value-of select="@src"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="@src"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:attribute>
				</xsl:when>
				<xsl:when test="$chartSrc = 'srcemail'">
					<xsl:attribute name="src"><xsl:value-of select="@srcemail" /></xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
						<xsl:if test="$strict='true'">
					<xsl:attribute name="src">graphic</xsl:attribute>
						</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="@chart_width">
				<xsl:attribute name="width"><xsl:value-of select="@chart_width" /></xsl:attribute>
			</xsl:if>
			<xsl:if test="@chart_height">
				<xsl:attribute name="height"><xsl:value-of select="@chart_height" /></xsl:attribute>
			</xsl:if>
			<xsl:if test="@usemap">
				<xsl:attribute name="usemap">#<xsl:value-of select="$namespaceId"/><xsl:value-of select="@usemap" /></xsl:attribute>
				<xsl:if test="$strict='false'">
					<xsl:attribute name="border">0</xsl:attribute>
				</xsl:if>
			</xsl:if>			
			<xsl:choose>
				<xsl:when test="$accessible='true'">
					<xsl:attribute name="alt"><xsl:value-of select="@altText" /></xsl:attribute>
				</xsl:when>
				<xsl:when test="$strict='true'">
					<xsl:attribute name="alt"><xsl:value-of select="@name" /></xsl:attribute>
				</xsl:when>
			</xsl:choose>
		</img>
		<xsl:variable name="sUseScale">
			<xsl:choose>
				<xsl:when test='contains(@chart_width, "%") or contains(@chart_height, "%")'>true</xsl:when>
				<xsl:otherwise>false</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>						
		<xsl:variable name="sIsImage">
			<xsl:choose>
				<xsl:when test="@layoutClass='image' or @layoutClass='richTextImage' or @layoutClass='CMMMap'">true</xsl:when>
				<xsl:otherwise>false</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>						
		<xsl:if test="$email = 'false'">
			<script>
			<xsl:if test="$strict='false'">
				<xsl:attribute name="language">javascript</xsl:attribute>
			</xsl:if>
			<xsl:attribute name="type">text/javascript</xsl:attribute>
			<xsl:if test="$Xhtml='true'">
				<xsl:text disable-output-escaping="yes">
					//&lt;![CDATA[
				</xsl:text>
			</xsl:if>	
			<xsl:choose>
				<xsl:when test="$chartSrc='srcsave' or $chartSrc='srcsaveAs'">
					<!-- 
					Create the uri that points to the saved output chart in content manager.
					The variables are defined in html.xsl
					-->
					<xsl:variable name="sGraphicName">
						<xsl:choose>
							<xsl:when test="@srcsaveAs !=''">
								<xsl:value-of select="@srcsaveAs"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="@srcsave"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:variable>
					<xsl:choose>
						<xsl:when test="$strict = 'true'">
						<xsl:variable name="sChartName"><xsl:value-of select='concat ($pageNumber, "_", rsext:replace(string(generate-id(.)), ".", "_"))'/></xsl:variable>
					var graphicName<xsl:value-of select='$sChartName'/> = "<xsl:value-of select="rsext:javascriptencode(string($sGraphicName))"/>";
					var graphicSrc<xsl:value-of select='$sChartName'/> = gateway + searchDelimeter + startMethod + searchPathToOutput + "/" + graphicName<xsl:value-of select='$sChartName'/> + endMethod;
<xsl:if test="$testMode = 'true'">							graphicSrc<xsl:value-of select='$sChartName'/> = graphicName<xsl:value-of select='$sChartName'/>;
</xsl:if>
<xsl:text/>							displayChart("chart<xsl:value-of select="$sChartName"/>", graphicSrc<xsl:value-of select='$sChartName'/>, <xsl:value-of select="$sUseScale"/>, <xsl:value-of select="$sIsImage"/>);
						</xsl:when>
						<xsl:otherwise>
					var graphicName<xsl:value-of select='rsext:replace(string(generate-id(.)), ".", "_")'/> = "<xsl:value-of select="rsext:javascriptencode(string($sGraphicName))"/>";
					var graphicSrc<xsl:value-of select='rsext:replace(string(generate-id(.)), ".", "_")'/> = gateway + searchDelimeter + startMethod + searchPathToOutput + "/" + graphicName<xsl:value-of select='rsext:replace(string(generate-id(.)), ".", "_")'/> + endMethod;
<xsl:if test="$testMode = 'true'">							graphicSrc<xsl:value-of select='rsext:replace(string(generate-id(.)), ".", "_")'/> = graphicName<xsl:value-of select='rsext:replace(string(generate-id(.)), ".", "_")'/>;
</xsl:if>
<xsl:text/>							displayChart("chart<xsl:value-of select="generate-id(.)"/>", graphicSrc<xsl:value-of select='rsext:replace(string(generate-id(.)), ".", "_")'/>, <xsl:value-of select="$sUseScale"/>, <xsl:value-of select="$sIsImage"/>);
						</xsl:otherwise>
					</xsl:choose>					
				</xsl:when>
				<xsl:otherwise>
					var graphicSrc<xsl:value-of select='rsext:replace(string(generate-id(.)), ".", "_")'/> = document.images["chart<xsl:value-of select="generate-id(.)"/>"].src;
					displayChart("chart<xsl:value-of select="generate-id(.)"/>", "", <xsl:value-of select="$sUseScale"/>, <xsl:value-of select="$sIsImage"/>);
				</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="$Xhtml='true'">
				<xsl:text disable-output-escaping="yes">
					//]]&gt;
				</xsl:text>
			</xsl:if>
			</script>
		</xsl:if>
	</xsl:template>
	<!-- 
		The "mother of all templates". 
		It is faster to check @layoutClass procedurally than to specify the the @layoutClass= in the match clause. 
	-->
	<xsl:template match="*[@layoutClass]">
		<xsl:choose>
			<!--
		textItem
		queryItemRef
		textExpression
	-->
			<xsl:when test="@layoutClass='textItem' or @layoutClass='textExpression' or @layoutClass='richTextContent'  or (@layoutClass='hyperlink' and name()='OTI')">
				<span>
					<xsl:call-template name="GenCommonAttributes"/>
					<xsl:call-template name="GenBackgroundImage"/>
					<xsl:value-of select="rsext:htmlencode(string(.))" disable-output-escaping="yes"/>
				</span>
			</xsl:when>
			<!--
		**************************************************
		THIS SECTION SHOULD BE REMOVED.
		THESE ELEMENTS TO NOT EXIST IN THE LAYOUT SPEC
		BUT THEY ARE STILL BE GENERATED IN THE XML AS IF THEY DO

		crosstabInnerHeaderCell
		crosstabInnerFooterCell
		crosstabOuterHeaderCell
		crosstabOuterFooterCell
			<xsl:when test="@layoutClass='crosstabInnerHeaderCell' or @layoutClass='crosstabInnerFooterCell' or @layoutClass='crosstabOuterHeaderCell' or @layoutClass='crosstabOuterFooterCell'">
				<td>
					<xsl:call-template name="GenTDAttributes"/>
					<xsl:call-template name="GenEventHandlers"/>
					<xsl:call-template name="GenBackgroundImage"/>
					<xsl:call-template name="GenTDChildElements"/>
				</td>
			</xsl:when>
	-->
			<!--
		listColumnTitle
		listColumn
		rowCell

		These elements may inherit styles from their parents. This is the incorrect place to do this.
		This should have been accounted for in the generated XML because the related elements may
		not all be contained in the same row.

	-->
			<xsl:when test="@layoutClass='listColumnTitle' or @layoutClass='listColumnBody' or @layoutClass='rowCell'">
				<xsl:choose>
					<xsl:when test="( $strict='true' or $accessible='true' ) and (@layoutClass='listColumnTitle' or @layoutClass='crosstabLevel' or @layoutClass='levelHeader')">
				<th>
					<xsl:call-template name="GenTDAttributes"/>
					<!-- overwrite style with parent and self style -->
					<!--	TCB			<xsl:if test="@style | ../@style">
					<xsl:attribute name="style"><xsl:if test="../@style"><xsl:value-of select="../@style" /></xsl:if><xsl:if test="@style">;<xsl:value-of select="@style" /></xsl:if></xsl:attribute>
				</xsl:if> -->
					<xsl:if test="@style">
						<xsl:attribute name="style"><xsl:if test="@style"><xsl:value-of select="@style" /></xsl:if></xsl:attribute>
					</xsl:if>
					<xsl:call-template name="GenEventHandlers"/>
					<xsl:call-template name="GenTDChildElements"/>
				</th>
					</xsl:when>
					<xsl:otherwise>
				<td>
					<xsl:call-template name="GenTDAttributes"/>
					<!-- overwrite style with parent and self style -->
					<!--	TCB			<xsl:if test="@style | ../@style">
					<xsl:attribute name="style"><xsl:if test="../@style"><xsl:value-of select="../@style" /></xsl:if><xsl:if test="@style">;<xsl:value-of select="@style" /></xsl:if></xsl:attribute>
				</xsl:if> -->
					<xsl:if test="@style">
						<xsl:variable name="sBackgroundImage">
							<xsl:if test="@bgsrc or @bgsrcemail">
								<xsl:choose>
									<xsl:when test="$chartSrc = 'src'">
										<xsl:text disable-output-escaping="yes">;background-image:url(</xsl:text>
										<xsl:value-of select="@bgsrc" disable-output-escaping="yes"/>
										<xsl:text disable-output-escaping="yes">)</xsl:text>
									</xsl:when>
									<xsl:when test="$chartSrc = 'srcemail'">
										<xsl:text disable-output-escaping="yes">;background-image:url(</xsl:text>
										<xsl:value-of select="@bgsrcemail" disable-output-escaping="yes"/>
										<xsl:text disable-output-escaping="yes">)</xsl:text>
									</xsl:when>
								</xsl:choose>
							</xsl:if>
						</xsl:variable>
						<xsl:attribute name="style"><xsl:value-of select="@style" /><xsl:value-of select="$sBackgroundImage" /></xsl:attribute>
					</xsl:if>
					<xsl:call-template name="GenEventHandlers"/>
					<xsl:call-template name="GenBackgroundImage"/>
					<xsl:call-template name="GenTDChildElements"/>
				</td>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!--
		crosstabCorner	
		crosstabCell
		crosstabFact
		crosstabFactCell
		crosstabNodeMember
		crosstabMember
		repeaterBody

	-->
			<xsl:when test="@layoutClass='crosstabCorner' or @layoutClass='crosstabCell' or @layoutClass='crosstabNodeMember' or @layoutClass='crosstabFactCell' or @layoutClass='crosstabFact' or @layoutClass='crosstabMember' or @layoutClass='repeaterBody'">
				<xsl:choose>
					<xsl:when test="( $strict = 'true' or $accessible = 'true' ) and @layoutClass='crosstabNodeMember'">
						<th>
							<xsl:call-template name="GenTDAttributes"/>
							<xsl:call-template name="GenEventHandlers"/>
							<xsl:call-template name="GenTDChildElements"/>
						</th>
					</xsl:when>
					<xsl:otherwise>
						<td>
							<xsl:call-template name="GenTDAttributes"/>
							<xsl:call-template name="GenEventHandlers"/>
							<xsl:call-template name="GenBackgroundImage"/>
							<xsl:call-template name="GenTDChildElements"/>
							<xsl:if test="@layoutClass='crosstabCorner' and count(*)=0 and $strict = 'false'">
								<!-- if the crosstab corner has no children, add a tab stop -->
								<span tabIndex="0"></span>
							</xsl:if>
						</td>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- 
		listColumns
		listColumnTitles
		listRowCells
		crosstabRowLevels
		crosstabColumnLevels
		crosstabColumns
		crosstabRows

		There is no styling that should be applied to TRs. Any styling specified on these objects
		must be applied to their children. This really should be handled by the XML output generated,
		because TR may contain header cells and bodys cells (e.g. listColumn and rowCell elements).
	-->
			<xsl:when test="@layoutClass='listColumns' or @layoutClass='listColumnTitles' or @layoutClass='listRow' or @layoutClass='listRowCells' or @layoutClass='rowCells' or @layoutClass='crosstabColumnLevels' or @layoutClass='crosstabRowLevels' or @layoutClass='crosstabColumns' or @layoutClass='crosstabRows'">
				<tr>
					<xsl:apply-templates select="*"/>
					<!-- the table has no measures -->
					<xsl:if test="@layoutClass='crosstabRows' and count(*[@layoutClass='crosstabFactCell'])=0 and count(../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/*)=0 and count(*[@layoutClass='crosstabCorner'])=0 and (../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/@rowspan &lt; 2 or ../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/@rowspan='')">
						<xsl:choose>
							<!-- the condition meets when the layoutClass is crosstabRows which has colspan and vspan attributes or has vspan and no colspan attributes, ie the crosstabCorner has at least 2 rowspan and any number of colspan -->
							<xsl:when test="(../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/@colspan!='' and ../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/@rowspan='1') or (../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/@colspan='' and ../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/@rowspan!='')">
								<xsl:variable name="numColumn"><xsl:value-of select="../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/@colspan"/></xsl:variable>
								<xsl:variable name="numMultiple"><xsl:value-of select="count(../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/following-sibling::node())"/></xsl:variable>
								<td>
									<!-- get the total number of colspan -->
									<xsl:attribute name="colspan"><xsl:value-of select="$numColumn*$numMultiple"/></xsl:attribute>
								</td>
							</xsl:when>
							<!-- this condition exists when the crosstabCorner has 1 rowspan and any number of colspan -->
							<xsl:otherwise>
								<xsl:variable name="numColumns"><xsl:value-of select="count(../*[@layoutClass='crosstabRows']/*[@layoutClass='crosstabCorner']/following-sibling::node())"/></xsl:variable>
								<td>
									<!-- get the total number of colspan, don't count the crosstabCorner -->
									<xsl:attribute name="colspan"><xsl:value-of select="$numColumns"/></xsl:attribute>
								</td>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>						
				</tr>
			</xsl:when>
			<!-- 
		list
		crosstab
	-->
			<xsl:when test="@layoutClass='list' or @layoutClass='crosstab'">
				<xsl:if test="$strict = 'false' or count (./DR) &gt; 0">
				<table>
					<xsl:if test="$accessible='true'">
						<xsl:attribute name="role">grid</xsl:attribute>
					</xsl:if>
					<xsl:call-template name="GenCommonTableAttributes"/>
					<xsl:if test="$isNS6">
						<xsl:choose>
							<xsl:when test="../@style!=''">
								<xsl:variable name="sTextAlign" select="substring-after(../@style, 'text-align')"/>
								<xsl:variable name="sTextAlignCenter">
									<xsl:choose>
										<xsl:when test="contains(substring-before($sTextAlign, ';'), 'center')">true</xsl:when>
										<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'center')">true</xsl:when>
										<xsl:otherwise>false</xsl:otherwise>
									</xsl:choose>
								</xsl:variable>
								<xsl:variable name="sTextAlignRight">
									<xsl:choose>
										<xsl:when test="contains(substring-before($sTextAlign, ';'), 'right')">true</xsl:when>
										<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'right')">true</xsl:when>
										<xsl:otherwise>false</xsl:otherwise>
									</xsl:choose>
								</xsl:variable>
								<xsl:choose>
									<xsl:when test="@style and (../@layoutClass='tableCell' or ../@layoutClass='pageBody') and $sTextAlignCenter='true'">
										<xsl:attribute name="style">margin-left:auto;margin-right:auto;<xsl:value-of select="@style" /></xsl:attribute>
									</xsl:when>
									<xsl:when test="@style and (../@layoutClass='tableCell' or ../@layoutClass='pageBody') and $sTextAlignRight='true'">
										<xsl:attribute name="style">margin-left:auto;<xsl:value-of select="@style" /></xsl:attribute>
									</xsl:when>
								</xsl:choose>
								<xsl:if test="$sTextAlignCenter='false' and $sTextAlignRight='false' and ../../@style!=''">
									<xsl:variable name="sTextAlign2" select="substring-after(../../@style, 'text-align')"/>
									<xsl:variable name="sTextAlignCenter2">
										<xsl:choose>
											<xsl:when test="contains(substring-before($sTextAlign2, ';'), 'center')">true</xsl:when>
											<xsl:when test="not(contains($sTextAlign2, ';')) and contains($sTextAlign2, 'center')">true</xsl:when>
											<xsl:otherwise>false</xsl:otherwise>
										</xsl:choose>
									</xsl:variable>
									<xsl:variable name="sTextAlignRight2">
										<xsl:choose>
											<xsl:when test="contains(substring-before($sTextAlign2, ';'), 'right')">true</xsl:when>
											<xsl:when test="not(contains($sTextAlign2, ';')) and contains($sTextAlign2, 'right')">true</xsl:when>
											<xsl:otherwise>false</xsl:otherwise>
										</xsl:choose>
									</xsl:variable>
									<xsl:choose>
										<xsl:when test="@style and ../../@layoutClass='page' and $sTextAlignCenter2='true'">
											<xsl:attribute name="style">margin-left:auto;margin-right:auto;<xsl:value-of select="@style" /></xsl:attribute>
										</xsl:when>
										<xsl:when test="@style and ../../@layoutClass='page' and $sTextAlignRight2='true'">
											<xsl:attribute name="style">margin-left:auto;<xsl:value-of select="@style" /></xsl:attribute>
										</xsl:when>
									</xsl:choose>
								</xsl:if>
							</xsl:when>
							<xsl:when test="../../@style!=''">
								<xsl:variable name="sTextAlign" select="substring-after(../../@style, 'text-align')"/>
								<xsl:variable name="sTextAlignCenter">
									<xsl:choose>
										<xsl:when test="contains(substring-before($sTextAlign, ';'), 'center')">true</xsl:when>
										<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'center')">true</xsl:when>
										<xsl:otherwise>false</xsl:otherwise>
									</xsl:choose>
								</xsl:variable>
								<xsl:variable name="sTextAlignRight">
									<xsl:choose>
										<xsl:when test="contains(substring-before($sTextAlign, ';'), 'right')">true</xsl:when>
										<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'right')">true</xsl:when>
										<xsl:otherwise>false</xsl:otherwise>
									</xsl:choose>
								</xsl:variable>
								<xsl:choose>
									<xsl:when test="@style and ../../@layoutClass='page' and $sTextAlignCenter='true'">
										<xsl:attribute name="style">margin-left:auto;margin-right:auto;<xsl:value-of select="@style" /></xsl:attribute>
									</xsl:when>
									<xsl:when test="@style and ../../@layoutClass='page' and $sTextAlignRight='true'">
										<xsl:attribute name="style">margin-left:auto;<xsl:value-of select="@style" /></xsl:attribute>
									</xsl:when>
								</xsl:choose>
							</xsl:when>
						</xsl:choose>
					</xsl:if>
					<xsl:if test="$strict = 'true' and @name">
						<caption><xsl:value-of select="@name"/></caption>
					</xsl:if>
					<xsl:apply-templates select="*"/>
				</table>
				</xsl:if>
			</xsl:when>
			<!-- 
		repeater
	-->
			<xsl:when test="@layoutClass='repeater'">
				<xsl:choose>
					<xsl:when test="name() = 'DR'">
						<tr>
							<xsl:apply-templates select="*"/>
						</tr>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="$strict = 'false' or count (./DR) &gt; 0">  <!-- strict only, add caption for accessibility? -->
						<table>
							<xsl:call-template name="GenCommonTableAttributes"/>
							<xsl:if test="$isNS6">
								<xsl:choose>
									<xsl:when test="../@style!=''">
										<xsl:variable name="sTextAlign" select="substring-after(../@style, 'text-align')"/>
										<xsl:variable name="sTextAlignCenter">
											<xsl:choose>
												<xsl:when test="contains(substring-before($sTextAlign, ';'), 'center')">true</xsl:when>
												<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'center')">true</xsl:when>
												<xsl:otherwise>false</xsl:otherwise>
											</xsl:choose>
										</xsl:variable>
										<xsl:variable name="sTextAlignRight">
											<xsl:choose>
												<xsl:when test="contains(substring-before($sTextAlign, ';'), 'right')">true</xsl:when>
												<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'right')">true</xsl:when>
												<xsl:otherwise>false</xsl:otherwise>
											</xsl:choose>
										</xsl:variable>
										<xsl:choose>
											<xsl:when test="@style and (../@layoutClass='tableCell' or ../@layoutClass='pageBody') and $sTextAlignCenter='true'">
												<xsl:attribute name="style">margin-left:auto;margin-right:auto;<xsl:value-of select="@style" /></xsl:attribute>
											</xsl:when>
											<xsl:when test="@style and (../@layoutClass='tableCell' or ../@layoutClass='pageBody') and $sTextAlignRight='true'">
												<xsl:attribute name="style">margin-left:auto;<xsl:value-of select="@style" /></xsl:attribute>
											</xsl:when>
										</xsl:choose>
										<xsl:if test="$sTextAlignCenter='false' and $sTextAlignRight='false' and ../../@style!=''">
											<xsl:variable name="sTextAlign2" select="substring-after(../../@style, 'text-align')"/>
											<xsl:variable name="sTextAlignCenter2">
												<xsl:choose>
													<xsl:when test="contains(substring-before($sTextAlign, ';'), 'center')">true</xsl:when>
													<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'center')">true</xsl:when>
													<xsl:otherwise>false</xsl:otherwise>
												</xsl:choose>
											</xsl:variable>
											<xsl:variable name="sTextAlignRight2">
												<xsl:choose>
													<xsl:when test="contains(substring-before($sTextAlign, ';'), 'right')">true</xsl:when>
													<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'right')">true</xsl:when>
													<xsl:otherwise>false</xsl:otherwise>
												</xsl:choose>
											</xsl:variable>
											<xsl:choose>
												<xsl:when test="@style and ../../@layoutClass='page' and $sTextAlignCenter2='true'">
													<xsl:attribute name="style">margin-left:auto;margin-right:auto;<xsl:value-of select="@style" /></xsl:attribute>
												</xsl:when>
												<xsl:when test="@style and ../../@layoutClass='page' and $sTextAlignRight2='true'">
													<xsl:attribute name="style">margin-left:auto;<xsl:value-of select="@style" /></xsl:attribute>
												</xsl:when>
											</xsl:choose>
										</xsl:if>
									</xsl:when>
									<xsl:when test="../../@style!=''">
										<xsl:variable name="sTextAlign" select="substring-after(../../@style, 'text-align')"/>
										<xsl:variable name="sTextAlignCenter">
											<xsl:choose>
												<xsl:when test="contains(substring-before($sTextAlign, ';'), 'center')">true</xsl:when>
												<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'center')">true</xsl:when>
												<xsl:otherwise>false</xsl:otherwise>
											</xsl:choose>
										</xsl:variable>
										<xsl:variable name="sTextAlignRight">
											<xsl:choose>
												<xsl:when test="contains(substring-before($sTextAlign, ';'), 'right')">true</xsl:when>
												<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'right')">true</xsl:when>
												<xsl:otherwise>false</xsl:otherwise>
											</xsl:choose>
										</xsl:variable>
										<xsl:choose>
											<xsl:when test="@style and ../../@layoutClass='page' and $sTextAlignCenter='true'">
												<xsl:attribute name="style">margin-left:auto;margin-right:auto;<xsl:value-of select="@style" /></xsl:attribute>
											</xsl:when>
											<xsl:when test="@style and ../../@layoutClass='page' and $sTextAlignRight='true'">
												<xsl:attribute name="style">margin-left:auto;<xsl:value-of select="@style" /></xsl:attribute>
											</xsl:when>
										</xsl:choose>
									</xsl:when>
								</xsl:choose>
							</xsl:if>
							<xsl:apply-templates select="*"/>
						</table>
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- 
		page 
	-->
			<xsl:when test="@layoutClass='page'">
				<table cellpadding="0" cellspacing="0" border="0">
					<xsl:if test="$accessible='true'">
						<xsl:attribute name="role">presentation</xsl:attribute>
					</xsl:if>
					<xsl:call-template name="GenCommonAttributes"/>
					<xsl:call-template name="GenBackgroundImage"/>
					<xsl:apply-templates select="*"/>
				</table>
			</xsl:when>
			<!-- 
		block 
	-->
			<xsl:when test="@layoutClass='block'">
						<div>
							<xsl:call-template name="GenCommonAttributes"/>
							<xsl:call-template name="GenBackgroundImage"/>
							<xsl:apply-templates select="*"/>
						</div>
			</xsl:when>
			
			<xsl:when test="@layoutClass='TOC'">
						<div>
							<xsl:if test="$accessible='true'">
								<xsl:attribute name="role">navigation</xsl:attribute>
							</xsl:if>
							<xsl:call-template name="GenCommonAttributes"/>
							<xsl:call-template name="GenBackgroundImage"/>
							<xsl:apply-templates select="*"/>
						</div>
			</xsl:when>

			<xsl:when test="@layoutClass='TOCEntry'">
						<div>
							<xsl:call-template name="GenCommonAttributes"/>
							<xsl:call-template name="GenBackgroundImage"/>
							<xsl:apply-templates select="*"/>
						</div>
			</xsl:when>

			<xsl:when test="@layoutClass='TOC'">
						<div>
							<xsl:call-template name="GenCommonAttributes"/>
							<xsl:call-template name="GenBackgroundImage"/>
							<xsl:apply-templates select="*"/>
						</div>
			</xsl:when>

			<!--
		pageHeader
		pageFooter
		pageBody
	-->
			<xsl:when test="@layoutClass='pageHeader' or @layoutClass='pageBody' or @layoutClass='pageFooter'">
					<td>
						<xsl:call-template name="GenCommonAttributes"/>
						<xsl:call-template name="GenBackgroundImage"/>
						<xsl:choose>
							<xsl:when test="(@layoutClass='pageBody') and ((count(*) = 0) or (count(*) = 1 and count(*[@layoutClass='list']) = 1 and count(*[@layoutClass='list']/*) = 0))">
								<xsl:call-template name="startPage"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="*"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
			</xsl:when>
			<!-- 
		table
		repeaterTable 
	-->
			<xsl:when test="@layoutClass='table' or @layoutClass='repeaterTable' or @layoutClass='richTextTable'">
				<xsl:if test="$strict = 'false' or count (./DR) &gt; 0 or count(./OTR) &gt; 0"> 
				<table>
					<xsl:call-template name="GenCommonTableAttributes"/>
					<xsl:if test="$isNS6">
						<xsl:variable name="sTextAlign" select="substring-after(../@style, 'text-align')"/>
						<xsl:variable name="sTextAlignCenter">
							<xsl:choose>
								<xsl:when test="contains(substring-before($sTextAlign, ';'), 'center')">true</xsl:when>
								<xsl:when test="not(contains($sTextAlign, ';')) and contains($sTextAlign, 'center')">true</xsl:when>
								<xsl:otherwise>false</xsl:otherwise>
							</xsl:choose>
						</xsl:variable>
						<xsl:if test="@style and (../@layoutClass='tableCell' or ../@layoutClass='repeaterTableCell') and $sTextAlignCenter='true'">
							<xsl:attribute name="style">margin-left:auto;margin-right:auto;<xsl:value-of select="@style" /></xsl:attribute>
						</xsl:if>
					</xsl:if>
					<xsl:apply-templates select="*"/>
				</table>
				</xsl:if>
			</xsl:when>
			<!-- 
		tableRow
		repeaterTableRow 
	-->
			<xsl:when test="@layoutClass='tableRow' or @layoutClass='repeaterTableRow' or @layoutClass='tr'">
				<tr>
					<xsl:call-template name="GenCommonAttributes"/>
					<xsl:call-template name="GenBackgroundImage"/>
					<xsl:apply-templates select="*"/>
				</tr>
			</xsl:when>
			<!-- 
		tableCell
		repeaterTableCell 
	-->
			<xsl:when test="@layoutClass='tableCell' or @layoutClass='repeaterTableCell' or @layoutClass='td' or @layoutClass='th'">
				<xsl:choose>
					<xsl:when test="$accessible='true' and @layoutClass='tableCell' and @isTableHeader">
						<th>
							<xsl:call-template name="GenTDAttributes"/>
							<xsl:call-template name="GenEventHandlers"/>					
							<xsl:call-template name="GenBackgroundImage"/>
							<xsl:call-template name="GenTDChildElements"/>				
						</th>
					</xsl:when>
					<xsl:otherwise>
						<td>
							<xsl:call-template name="GenTDAttributes"/>
							<xsl:call-template name="GenEventHandlers"/>					
							<xsl:call-template name="GenBackgroundImage"/>
							<xsl:call-template name="GenTDChildElements"/>				
						</td>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!--
		section
	-->
			<xsl:when test="@layoutClass='section'">
				<xsl:if test="$strict = 'false' or count (./DR) &gt; 0"> <!-- strict only, add caption for accessibility --> 
				<table>
					<xsl:apply-templates select="*"/>
				</table>
				</xsl:if>
			</xsl:when>
			<!--
		sectionFooter
	-->
			<xsl:when test="@layoutClass='sectionFooter'"/>
			<!--
		image
	-->
			<xsl:when test="@layoutClass='image' or @layoutClass='richTextImage'">
				<xsl:choose>
					<xsl:when test="@processAttachment">
						<!-- Process the image as if it were a chart -->
						<xsl:call-template name="GenChartImageContainer"/>
					</xsl:when>
					<xsl:otherwise>
						<img>
							<xsl:call-template name="GenCommonAttributes"/>
							<xsl:if test="@src">
								<xsl:attribute name="src"><xsl:value-of select="@src" /></xsl:attribute>
							</xsl:if>
							<!-- Yes, this overwrites the src attribute.  I cannot find a better way in the rendering engine
							to accomplish this.  What happens is that if the image control is data driven, I will set the source
							attribute.  This takes presedence over hard-coded src attribute
							-->
							<xsl:if test="@source">
								<xsl:attribute name="src"><xsl:value-of select="@source" /></xsl:attribute>
							</xsl:if>
							<xsl:if test="@URL">
								<xsl:attribute name="src"><xsl:value-of select="@URL" /></xsl:attribute>
							</xsl:if>
							<xsl:choose>
								<xsl:when test="$accessible='true'">
									<xsl:attribute name="alt"><xsl:value-of select="@altText" /></xsl:attribute>
								</xsl:when>
								<xsl:when test="$strict='true'">
									<xsl:attribute name="alt"><xsl:value-of select="@name" /></xsl:attribute>
								</xsl:when>
							</xsl:choose>
							<xsl:call-template name="GenBackgroundImage"/>
							<xsl:apply-templates/>
						</img>
					</xsl:otherwise>
			</xsl:choose>
			</xsl:when>
			<!--
		pieChart
		paretoChart
		scatterChart
		polarChart
		radarChart
		progressiveChart
		combinationChart
		bubbleChart
		threeDCombinationChart
		threeDScatterChart
		gaugeChart
		mapChart
		metricsChart
		marimekkoChart
		CMMMap
	-->
			<xsl:when test="@layoutClass='pieChart' or @layoutClass='v2_pieChart' or @layoutClass='paretoChart' or @layoutClass='v2_paretoChart' or @layoutClass='scatterChart' or @layoutClass='v2_scatterChart' or @layoutClass='polarChart' or @layoutClass='radarChart' or @layoutClass='progressiveChart' or @layoutClass='v2_progressiveChart' or @layoutClass='combinationChart' or @layoutClass='v2_combinationChart' or @layoutClass='bubbleChart' or @layoutClass='v2_bubbleChart' or @layoutClass='threeDCombinationChart' or @layoutClass='threeDScatterChart' or @layoutClass='gaugeChart' or @layoutClass='v2_gaugeChart' or @layoutClass='metricsChart' or @layoutClass='mapChart' or @layoutClass='CMMMap' or @layoutClass='marimekkoChart'">
				<xsl:if test="string(@useFlash) !='true'">
					<xsl:call-template name="GenChartImageContainer"/>
				</xsl:if>
			</xsl:when>
			<!--
		chart map
	-->
			<xsl:when test="@layoutClass='chart_map'">
				<map>
					<xsl:call-template name="GenCommonAttributes"/>
					<xsl:if test="$strict='true'">
						<xsl:attribute name="id">map<xsl:value-of select="$pageNumber"/>-<xsl:value-of select="generate-id(.)"/></xsl:attribute>
					</xsl:if>
					<xsl:if test="@name">
						<xsl:attribute name="name"><xsl:value-of select="$namespaceId"/><xsl:value-of select="@name" /></xsl:attribute>
					</xsl:if>
					<xsl:for-each select="./*">
						<xsl:if test="@layoutClass='chart_area'">
							<area>
								<xsl:call-template name="GenCommonAttributes"/>
								<xsl:if test="@type and $strict='false'">
									<xsl:attribute name="type"><xsl:value-of select="@type" /></xsl:attribute>
								</xsl:if>
								<xsl:if test="@shape">
									<xsl:attribute name="shape"><xsl:value-of select="@shape" /></xsl:attribute>
								</xsl:if>
								<xsl:if test="@coords">
									<xsl:attribute name="coords"><xsl:value-of select="@coords" /></xsl:attribute>
								</xsl:if>
								<xsl:if test="@title">
									<xsl:attribute name="title"><xsl:value-of select="@title"/></xsl:attribute>
								</xsl:if>
								<xsl:if test="@roid">
									<xsl:attribute name="roid"><xsl:value-of select="@roid" /></xsl:attribute>
								</xsl:if>																							
								<xsl:if test="@sSpecName">
									<xsl:attribute name="sSpecName"><xsl:value-of select="@sSpecName" /></xsl:attribute>
								</xsl:if>
								<xsl:if test="@ctx">
									<xsl:attribute name="ctx"><xsl:value-of select="@ctx" /></xsl:attribute>
								</xsl:if>
								<xsl:if test="$strict ='false'">
									<xsl:attribute name="tabIndex">-1</xsl:attribute>
								</xsl:if>
								<xsl:choose>
									<xsl:when test="$strict='true'"> 
										<xsl:attribute name="alt"><xsl:value-of select="@type" /></xsl:attribute>
									</xsl:when>
									<xsl:otherwise>
										<xsl:if test="$accessible='true'">
											<xsl:attribute name="alt"><xsl:value-of select="@altText" /></xsl:attribute>
										</xsl:if>
										<!-- apply drill/up down links if meta data exists for this chart area -->
										<xsl:apply-templates select="self::node()"/>	
									</xsl:otherwise>									
								</xsl:choose>
							</area>
						</xsl:if>
					</xsl:for-each>
				</map>
			</xsl:when>
			<!--
			RichTextItem, CustomContent ol, ul, li, span, div
			-->
			<xsl:when test="@layoutClass='richTextItem' or @layoutClass='customContent'">
						
							<xsl:apply-templates select="*"/>
						
			</xsl:when>
			
			<xsl:when test="@layoutClass='div'">
						<div>
							<xsl:call-template name="GenRTAttributes"/>
							<xsl:apply-templates select="*"/>
						</div>
			</xsl:when>
			
			<xsl:when test="@layoutClass='span'">
						<span>
							<xsl:call-template name="GenRTAttributes"/>
							<xsl:apply-templates select="*"/>
						</span>
			</xsl:when>
			
			<xsl:when test="@layoutClass='ol'">
						<ol>
							<xsl:call-template name="GenRTAttributes"/>
							<xsl:apply-templates select="*"/>
						</ol>
			</xsl:when>
			
			<xsl:when test="@layoutClass='ul'">
						<ul>
							<xsl:call-template name="GenRTAttributes"/>
							<xsl:apply-templates select="*"/>
						</ul>
			</xsl:when>
			
			<xsl:when test="@layoutClass='li'">
						<li>
							<xsl:call-template name="GenRTAttributes"/>
							<xsl:apply-templates select="*"/>
						</li>
			</xsl:when>
			
			<!-- 	
		Hyperlink 	
	-->
			<xsl:when test="name()='OHL'">
			<xsl:choose>
				<xsl:when test="$hyperlinkMultipleToolbars='false'">
					<a href="{@href}" target="_parent" >
						<xsl:call-template name="GenCommonAttributes"/>
						<xsl:apply-templates select="*"/>
					</a>
				</xsl:when>
				<xsl:otherwise>
					<a href="{@href}">
						<xsl:call-template name="GenCommonAttributes"/>
						<xsl:apply-templates select="*"/>
					</a>
				</xsl:otherwise>
			</xsl:choose>			
			</xsl:when>
			<!-- 	
		HTML Item	
	-->
			<xsl:when test="@layoutClass='HTMLItem'">
				<xsl:value-of disable-output-escaping="yes" select="."/>
			</xsl:when>
			<!-- 	
		Bookmark
	-->
			<xsl:when test="@layoutClass='bookmark'">
				<a>
					<xsl:choose>
						<xsl:when test="$strict = 'true'">
					<xsl:attribute name="name"><xsl:value-of select="rsext:replace (rsext:urlencode(string(@name)), '+', '-')"/></xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
					<xsl:attribute name="name"><xsl:value-of select="rsext:urlencode(string(@name))"/></xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
				</a>
			</xsl:when>
			
			<xsl:when test="@layoutClass='TOCBookmark'">
				<a>
					<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
				</a>
			</xsl:when>

			<!-- 	
		Button	
	-->
			<xsl:when test="@layoutClass='button'">
				<xsl:variable name="sCommand">
					<xsl:choose>
						<xsl:when test="not(@href) or @href=''"/>
						<xsl:otherwise>if(window.name){window.open('<xsl:value-of select="@href"/>',window.name);}else{<xsl:choose><xsl:when test="$hyperlinkButtonNewWindow='false'">parent.location='<xsl:value-of select="@href"/>';</xsl:when><xsl:otherwise>window.open('<xsl:value-of select="@href"/>',window.name);</xsl:otherwise></xsl:choose>}</xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<!-- we are using a table instead of a span, because NS6+ won't render the span correctly if an image is in it -->
				<button onclick="{$sCommand}">
					<xsl:call-template name="GenCommonAttributes"/>
					<xsl:call-template name="GenBackgroundImage"/>
					<xsl:apply-templates select="*"/>
				</button>
				<!-- if we need NS6 to support images in buttons we can add this in a if for NS6
			<table cellspacing="0" border="0" onMouseDown="{$sCommand}">
				<xsl:call-template name="GenCommonAttributes"/>
				<tr><td>
					<xsl:apply-templates select="*"/>
				</td></tr>
			</table>
			-->
			</xsl:when>
			<xsl:when test="@layoutClass='fieldSet'">
				<fieldset>
					<xsl:call-template name="GenCommonAttributes"/>
					<xsl:call-template name="GenBackgroundImage"/>
					<xsl:apply-templates select="*[name() = 'caption']"/>
					<xsl:apply-templates select="*[not(name() = 'caption')]"/>
				</fieldset>	
			</xsl:when>
			<xsl:when test="@layoutClass='fieldSetCaption'">
				<legend>
					<xsl:if test="$strict='false'">
						<xsl:attribute name="align"><xsl:value-of select="./@showCaption"/></xsl:attribute>
					</xsl:if>
					<xsl:call-template name="GenCommonAttributes"/>
					<xsl:call-template name="GenBackgroundImage"/>
					<xsl:apply-templates select="*"/>
				</legend>	
			</xsl:when>
		</xsl:choose>		
	</xsl:template>
	<!-- sectionHeader DR -->
	<xsl:template match="DR[@layoutClass='sectionHeader']">
		<tr>
			<xsl:apply-templates select="*"/>
		</tr>
	</xsl:template>
	<!-- sectionHeader DRI -->
	<xsl:template match="DRI[@layoutClass='sectionHeader']">
		<td>
			<xsl:call-template name="GenTDAttributes"/>
			<xsl:call-template name="GenEventHandlers"/>
			<xsl:attribute name="class">sh</xsl:attribute>
			<xsl:call-template name="GenBackgroundImage"/>
			<xsl:apply-templates select="*"/>
		</td>
	</xsl:template>
	<!-- sectionBody DR -->
	<xsl:template match="DR[@layoutClass='sectionBody']">
		<tr>
			<xsl:apply-templates select="*"/>
		</tr>
	</xsl:template>
	<!-- sectionBody DRI -->
	<xsl:template match="DRI[@layoutClass='sectionBody']">
		<td>
			<xsl:apply-templates select="*"/>
		</td>
	</xsl:template>
	<!-- XMLItem -->
	<xsl:template match="XMLItem">
		<xsl:value-of disable-output-escaping="yes" select="@value"/>
	</xsl:template>
	<!-- remove bogus row for next or previous controls -->
	<xsl:template match="DR[@type='next'] | DR[@type='previous']"/>
	<!--	FieldSet	
	<xsl:template match="fieldSet">
		<fieldset class="fieldset">
			<xsl:if test="@style">
				<xsl:attribute name="style"><xsl:value-of select="@style" /></xsl:attribute>
			</xsl:if>
			<xsl:call-template name="genCaption">
				<xsl:with-param name="showCaption" select="./@showCaption"/>
				<xsl:with-param name="style" select="./caption/OTI/@style"/>
				<xsl:with-param name="class" select="./caption/OTI/@class"/>
				<xsl:with-param name="caption" select="./caption/OTI"/>
			</xsl:call-template>
			<xsl:apply-templates select="*[not(name() = 'caption')]"/>
		</fieldset>
	</xsl:template>-->
	<xsl:template name="genCaption">
		<xsl:param name="showCaption"/>
		<xsl:param name="style"/>
		<xsl:param name="class"/>
		<xsl:param name="styleId"/>
		<xsl:param name="caption"/>
		<xsl:element name="legend">
			<xsl:if test=" not($showCaption= '') ">
				<xsl:attribute name="align"><xsl:value-of select="$showCaption"/></xsl:attribute>
			</xsl:if>
			<xsl:element name="span">
				<xsl:if test="not($styleId)">
				<xsl:attribute name="style"><xsl:value-of select="$style"/></xsl:attribute>
				</xsl:if>
				<xsl:attribute name="class"><xsl:value-of select="$class"/><xsl:text> </xsl:text><xsl:value-of select="$styleId"/></xsl:attribute>
				<xsl:value-of select="$caption"/>
			</xsl:element>
		</xsl:element>
	</xsl:template>
	
	<xsl:template name="chartConfig">
		<xsl:if test="$chartSupport = 'true' and $chartSrc != 'srcemail' and $appSupport='false'">
<script>
	<xsl:if test="$strict='false'">
		<xsl:attribute name="language">javascript</xsl:attribute>
	</xsl:if>
	<xsl:attribute name="type">text/javascript</xsl:attribute>
	<xsl:if test="$Xhtml='true'">
		<xsl:text disable-output-escaping="yes">
			//&lt;![CDATA[
		</xsl:text>
	</xsl:if>
				<xsl:text disable-output-escaping="yes">
function isIE()
{
	return (navigator.userAgent.indexOf('MSIE') != -1);
}

function getNavVer()
{
	if (isIE()){
		var temp=navigator.userAgent.split('MSIE');
		return parseFloat(temp[1]);
	} else {
		<!-- Firefox and Netscape's version is last thing after the '/' on navigator.userAgent value -->
		var temp = navigator.userAgent.split('\/');
		return parseFloat(temp[temp.length - 1]);
	}
}

function preprint()
{
	if (isIE() &amp;&amp; getNavVer() &gt;= 5.5 &amp;&amp; getNavVer() &lt; 7.0) {
		var alltags = document.images;
		
		for (var i=0; i &lt; alltags.length; i++){
			if (alltags[i].className == 'ch'){
				if (alltags[i].srcbackup){
					alltags[i].src = alltags[i].srcbackup;
				}
			}
		}	
	}
}

function postprint()
{
	if (isIE() &amp;&amp; getNavVer() &gt;= 5.5 &amp;&amp; getNavVer() &lt; 7.0) {
		var alltags = document.images;
		
		for (var i=0; i &lt; alltags.length; i++){
			if (alltags[i].className == 'ch'){
				if (alltags[i].srcbackup){
					alltags[i].src = '../ps/images/space.gif';
				}
			}
		}
	}
}

if (isIE() &amp;&amp; getNavVer() &gt;= 5.5 &amp;&amp; getNavVer() &lt; 7.0) {
	window.onbeforeprint=preprint;
	window.onafterprint=postprint;
}

function displayChart(imageName, imgSrc, useScale, isImage)
{
	if (isIE() &amp;&amp; getNavVer() &gt;= 5.5 &amp;&amp; getNavVer() &lt; 7.0) {
		var oImg = document.images[imageName];
		var strOldImg;
		if (imgSrc.length &gt; 1){
			strOldImg = imgSrc;
		} else {
			strOldImg = oImg.src;
		}

		var imgURL = strOldImg;
		oImg.srcbackup = imgURL;
		
		<!-- 
		Preserve URL encoding by encoding % character.
		The inbound URL arguments encode %, &, = and + 
		The filter expects these to still be encoded so we encoded % as %25 to preserve the encoding
		-->
		
		strOldImg = strOldImg.replace(new RegExp(/%/g), "%25");
		// BUG: IE's display filter parser is broken and incorrectly sees any closing
		// brackets contained in an href as the end of a filter expression .. so we need to escape them
		strOldImg = strOldImg.replace(/\x28/g, "%28");
		strOldImg = strOldImg.replace(/\x29/g, "%29");
		
		var strSizing = useScale ? "scale" : "crop";
		if ( isImage ) {
				strSizing = "image";
		}
				</xsl:text>
			<xsl:choose>
			<xsl:when test="$chartEnableTransparencyIE = 'true'">
				<xsl:text disable-output-escaping="yes">
		oImg.src = '../ps/images/space.gif';
		oImg.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + strOldImg + "',sizingMethod='" + strSizing + "');";
				</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text disable-output-escaping="yes">
		document.images[imageName].src = imgURL;
				</xsl:text>
			</xsl:otherwise>
			</xsl:choose>					
				<xsl:text disable-output-escaping="yes">					
	} else {
		if (imgSrc.length &gt; 1){
			document.images[imageName].src = imgSrc;
		}
	}
}			
				</xsl:text>
		<xsl:if test="$chartSrc = 'srcsave' or $chartSrc='srcsaveAs'">
			<!-- Add code to find saved charts -->
			<xsl:text disable-output-escaping="yes">
function getSearchStringArgs() 
{
	var args = new Object();
	var query = location.search.substring(1); 
	var pairs = query.split("&amp;"); 
	for(var i = 0; i &lt; pairs.length; i++) 
	{
		var pos = pairs[i].indexOf('=');
		if (pos == -1) continue;  
		var argname = pairs[i].substring(0,pos); 
		if (argname == "search")
		{
			var value = pairs[i].substring(pos+1); 
			args[argname] = value;
			break;
		}
	}
	return args; 
}			
var gateway = location.protocol + "//" + location.host + location.pathname;
var startMethod = "SM=query&amp;search=";
var searchDelimeter = "?";
var endMethod = "&amp;SA=propEnum,properties&amp;ITEM=data&amp;EA=&amp;SS=queryOptions,options&amp;dataEncoding=MIME&amp;ES=&amp;EM=";	
var searchStringArgs = getSearchStringArgs();
var searchPathToOutput = searchStringArgs["search"];

function displayBackground (sBackgroundName, sGraphicName, isTest)
{
	var graphicSrc = gateway + searchDelimeter + startMethod + searchPathToOutput + "/" + sGraphicName + endMethod;
	if (isTest)
		graphicSrc = sGraphicName;
	var scriptElement = document.scripts(sBackgroundName);
	
	if (scriptElement != null &amp;&amp; scriptElement.parentElement != null)
		scriptElement.parentElement.style.backgroundImage = "url(" + graphicSrc + ")";
}
</xsl:text>
		</xsl:if>
		<xsl:if test="$Xhtml='true'">
			<xsl:text disable-output-escaping="yes">
				//]]&gt;
			</xsl:text>
		</xsl:if>
</script>
</xsl:if>
</xsl:template>

<xsl:template name="textAlignForFireFox">
	<xsl:if test="$appSupport='false'">
	<script type="text/javascript">
				<xsl:if test="$Xhtml='true'">
					<xsl:text disable-output-escaping="yes">//&lt;![CDATA[
</xsl:text>
				</xsl:if>			
<xsl:text  disable-output-escaping="yes">
			var userAgent = navigator.userAgent.toLowerCase();
			if ( (userAgent.indexOf("mozilla") &gt; -1 &amp;&amp; userAgent.indexOf ("msie") &lt; 0)
			|| (userAgent.indexOf("firefox") &gt; -1))
			{
					var style = document.createElement ("style");

					style.setAttribute ("type", "text/css");
						
					var head = document.documentElement.getElementsByTagName ("head");
						
					if (head.length > 0)
						head.item (0).appendChild	(style);
					
					if (document.styleSheets.length &gt; 0)
					{
						style.sheet.insertRule ("*[style*='text-align: right']{	  text-align:-moz-right !important;	  } ", 0);
						style.sheet.insertRule ("*[style*='text-align: center']{	  text-align:-moz-center !important;	  } ", 0);
					}
					
					for (index = 0; index &lt; document.styleSheets.length; index++)
					{
						var styleSheet = document.styleSheets.item (index);
						
						for (iRule = 0; iRule &lt; styleSheet.cssRules.length; iRule++)
						{
							var rule = styleSheet.cssRules.item (iRule);
							
							if (rule.style != null)
							{
								var alignment = rule.style.getPropertyValue ("text-align");
								
								if (alignment != null &amp;&amp; alignment.length &gt; 0)
								{
									if (alignment == "center")
											rule.style.setProperty ("text-align", "-moz-center", "important");
									else if (alignment == "right")
											rule.style.setProperty ("text-align", "-moz-right", "important");
								}
							}
						}
					}
			  }
</xsl:text>									  
				<xsl:if test="$Xhtml='true'">
<xsl:text disable-output-escaping="yes">//]]&gt;</xsl:text>
				</xsl:if>			
	</script>
	</xsl:if>
</xsl:template>

<!-- For crosstabs and lists only the first cell should have a tabIndex of 0, all other cells need a tabIndex of -1 -->
<xsl:template name="GenTabIndexAttribute">
	<xsl:if test="$strict ='false'">
		<xsl:choose>
			<xsl:when test="parent::node()/parent::node()/parent::node()/@layoutClass = 'list' or parent::node()/parent::node()/parent::node()/@layoutClass = 'crosstab'">
				<xsl:choose>
					<xsl:when test="parent::node()/@isFirstCell"> <!-- the isFirstCell attribute is added to a table's first cell -->
						<xsl:attribute name="tabIndex">0</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="tabIndex">-1</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="tabIndex">0</xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:if>
</xsl:template>

<xsl:template name="AddAccessibleTagsForSpan">
	<xsl:if test="$accessible='true'">
		<xsl:if test="parent::node()/@headers">
			<xsl:variable name="viewerID">
				<xsl:choose>
					<xsl:when test="string($CognosViewerID)=''"><xsl:value-of select="'_THIS_'"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="$CognosViewerID"/></xsl:otherwise>
				</xsl:choose>
			</xsl:variable>		
			<!-- Need a unique id to put on the span for the aria-labelledby -->
			<xsl:variable name="uniqueId"><xsl:value-of select="concat($viewerID, generate-id(.), $pageNumber)"/></xsl:variable>
			<xsl:attribute name="id"><xsl:value-of select="$uniqueId"/></xsl:attribute>
			<xsl:attribute name="aria-labelledby">
					<xsl:value-of select='concat(rsext:replace(parent::node()/@headers, "hdr", concat($viewerID, "hdr")), " ")'/>
				<xsl:value-of select='$uniqueId'/>
			</xsl:attribute>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="parent::node()/@layoutClass = 'crosstabNodeMember'">
				<xsl:choose>
					<xsl:when test="parent::node()/parent::node()/@isTopLabel">
						<xsl:attribute name="role">columnheader</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="role">rowheader</xsl:attribute>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="role">gridcell</xsl:attribute>			
			</xsl:otherwise>
		</xsl:choose>
	</xsl:if>
</xsl:template>
</xsl:stylesheet>
