<?xml version="1.0" encoding="UTF-8"?>
<!--
Licensed Materials - Property of IBM

IBM Cognos Products: rsvp

(C) Copyright IBM Corp. 2005, 2010

US Government Users Restricted Rights - Use, duplication or disclosure 
restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<!-- COPYRIGHT_DATA {'RELEASE': ['2005', '2009', 'colorado_wave1', 'colorado_wave2'], 'VISIBLE': 'YES', 'COMPONENT': 'rsvp'}-->
<!--All lines above the COPYRIGHT_DATA  line will be replaced when copyright notices are generated. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:bus="http://developer.cognos.com/schemas/bibus/3/" xmlns:rsext="xalan://com.cognos.reportserver.ext.RSExt">
 <xsl:output method="html" version="1.0" encoding="UTF-8" indent="no"/>
	<!-- 
		drill head 
	-->
	<xsl:template name="getDrillThruHead">
		<xsl:if test="$appSupport='false'">
		<xsl:choose>
			<xsl:when test="$drillSupport='yes' and $sdkDrillSupport='false'">
				<xsl:text disable-output-escaping="yes">&lt;script type="text/javascript" src="../cr1/drill.js"&gt;&lt;/script&gt;</xsl:text>
				<xsl:text disable-output-escaping="yes">&lt;script type="text/javascript" src="../rv/CDrillThroughTarget.js"&gt;&lt;/script&gt;</xsl:text>
				<xsl:call-template name="addDrillThroughContext">
					<xsl:with-param name="closeScript" select="'yes'"/>
				</xsl:call-template>			
			</xsl:when>
			<xsl:when test="$drillSupport='inline' or $sdkDrillSupport='true'">
				<xsl:choose>
					<xsl:when test="$strict='true'">
				<xsl:text disable-output-escaping="yes">&lt;script type="text/javascript"&gt;</xsl:text>
					</xsl:when>
					<xsl:otherwise>
				<xsl:text disable-output-escaping="yes">&lt;script language="javascript" type="text/javascript"&gt;</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="$Xhtml='true' or $strict = 'true'">
					<xsl:text disable-output-escaping="yes">
						//&lt;![CDATA[
					</xsl:text>
				</xsl:if>			
				<xsl:text disable-output-escaping="yes">				
function CDrillThroughTarget(label, outputFormat, outputLocale, showInNewWindow, method, path, bookmarkRef, parameters, objectPaths, sPrompt, sendFilterContext, parameterProperties)
{
	this.m_label = label;
	this.m_outputFormat = outputFormat;
	this.m_outputLocale = outputLocale;
	this.m_showInNewWindow = showInNewWindow;
	this.m_method = method;
	this.m_path = path;
	this.m_bookmarkRef = bookmarkRef;
	this.m_parameters = parameters;
	this.m_objectPaths = objectPaths;
	this.m_prompt = "false";
	this.m_sendFilterContext = sendFilterContext;
	this.m_parameterProperties = parameterProperties;

	if (typeof sPrompt != 'undefined' &amp;&amp; sPrompt != null)
	{
		if (sPrompt == 'yes')
		{
			this.m_prompt = "true";
		}
		else if (sPrompt == 'target')
		{
			this.m_prompt = '';
		}
	}
}

function doSingleDrillThrough(drillThroughContext, bookmarkRef, cvId)
{
	// handle a single drill
	var drillTargetRefIdx = drillThroughContext[0][0];
	if(typeof drillTargetRefIdx == "undefined" || drillTargetRefIdx == null)
		return;	
		
	var drillTargetRef = drillTargets[drillTargetRefIdx];
	if(typeof drillTargetRef == "undefined")
		return;
	
	// check for the case of a local bookmark	
	if(bookmarkRef != '' &amp;&amp; drillTargetRef.m_path == '') {</xsl:text>

				<xsl:choose>
					<xsl:when test="$mht='true'">
<xsl:text disable-output-escaping="yes">				
		docLocation( bookmarkRef );</xsl:text>
					</xsl:when>
					<xsl:otherwise>
<xsl:text disable-output-escaping="yes">				
		document.location = "#" + bookmarkRef;</xsl:text>
					</xsl:otherwise>
				</xsl:choose>

<xsl:text disable-output-escaping="yes">				
	} else {
		var args = new Array;
		args[args.length] = new Array("ui.object", drillTargetRef.m_path);
		for(var drillParmIdx = 1; drillParmIdx &lt; drillThroughContext.length; ++drillParmIdx) {
			args[args.length] = drillThroughContext[drillParmIdx];
		}
		
		var drillForm = document.getElementById("multiDrillForm");
		if(drillForm == null)
			return;
			
		drillForm["ui.action"].value = drillTargetRef.m_method;	
		drillForm["run.outputFormat"].value = drillTargetRef.m_outputFormat;
		drillForm["run.outputLocale"].value = drillTargetRef.m_outputLocale;
		drillForm["run.prompt"].value = drillTargetRef.m_prompt;
		drillForm["ui.bookmark"].value = bookmarkRef;

		if (drillTargetRef.m_method == "view") {
			drillForm["ui.object"].value = "defaultOutput(" + args[0][1] + ",\&quot;" + drillTargetRef.m_outputFormat + "\&quot;,\&quot;\&quot;)";
		}
		else {
			drillForm["ui.object"].value = args[0][1];
			var formField;
			for (var i = 1; i &lt; args.length; i++) {
				formField = document.createElement(&quot;input&quot;);
				formField.setAttribute(&quot;type&quot;, &quot;hidden&quot;);
				formField.setAttribute(&quot;name&quot;, args[i][0]);
				formField.setAttribute(&quot;value&quot;, args[i][1]);
				drillForm.appendChild(formField);
			}
					
			drillForm["sourceContext"].value = drillTargetRef.m_parameters;
			drillForm["objectPaths"].value = drillTargetRef.m_objectPaths;
		}
		
		drillForm.submit();
	}
}
function doMultipleDrillThrough(drillThroughContext, cvId)
{
	// handle multiple drills
	var drillThroughTargetStr = '&lt;rvDrillTargets&gt;';
	
	for(var drillTargetIdx = 0; drillTargetIdx &lt; drillThroughContext.length; ++drillTargetIdx) {
	
		var currentDrillThroughContext = drillThroughContext[drillTargetIdx];
		if(currentDrillThroughContext.length &lt; 3) {
			// there must be three or more parameters (drill idx, drill label and the drill parameters)
			continue;
		}
		
		var drillTargetRefIdx = currentDrillThroughContext[0];
		if(typeof drillTargetRefIdx == "undefined" || drillTargetRefIdx == null)
			continue;
			
		var drillTargetLabel = currentDrillThroughContext[1];
		if(typeof drillTargetLabel == "undefined" || drillTargetLabel == null)
			continue;
			
		var drillTargetRef = drillTargets[drillTargetRefIdx];
		if(typeof drillTargetRef == "undefined" || drillTargetRef == null)
			continue; 
		
		drillThroughTargetStr += '&lt;drillTarget ';
		
		drillThroughTargetStr += 'outputFormat="'; drillThroughTargetStr += drillTargetRef.m_outputFormat; drillThroughTargetStr += '" ';
		drillThroughTargetStr += 'outputLocale="'; drillThroughTargetStr += drillTargetRef.m_outputLocale; drillThroughTargetStr += '" ';					
		drillThroughTargetStr += 'prompt="'; drillThroughTargetStr += drillTargetRef.m_prompt; drillThroughTargetStr += '" ';					
		drillThroughTargetStr += 'label="'; drillThroughTargetStr += drillTargetLabel; drillThroughTargetStr += '" ';					
		drillThroughTargetStr += 'path="'; drillThroughTargetStr += drillTargetRef.m_path; drillThroughTargetStr += '" ';					
		drillThroughTargetStr += 'showInNewWindow="'; drillThroughTargetStr += drillTargetRef.m_showInNewWindow; drillThroughTargetStr += '" ';	
		drillThroughTargetStr += 'method="'; drillThroughTargetStr += drillTargetRef.m_method; drillThroughTargetStr += '">';	
		
		for(var drillParmIdx = 2; drillParmIdx &lt; currentDrillThroughContext.length; ++drillParmIdx) {
			drillThroughTargetStr += currentDrillThroughContext[drillParmIdx];		
		}
				
		drillThroughTargetStr += drillTargetRef.m_parameters;
		drillThroughTargetStr += drillTargetRef.m_objectPaths;

		drillThroughTargetStr += '&lt;/drillTarget&gt;';			
	}

	drillThroughTargetStr += '&lt;/rvDrillTargets&gt;';	


	var multiDrillForm = document.getElementById("multiDrillForm");
	if(multiDrillForm == null)
		return;
	
	multiDrillForm.drillTargets.value = drillThroughTargetStr;	

	var formField = document.createElement(&quot;input&quot;);
	formField.setAttribute(&quot;type&quot;, &quot;hidden&quot;);
	formField.setAttribute(&quot;name&quot;, &quot;invokeGotoPage&quot;);
	formField.setAttribute(&quot;value&quot;, &quot;true&quot;);
	multiDrillForm.appendChild(formField);

	multiDrillForm.submit();
}
</xsl:text>
<xsl:if test="$Xhtml='true' or $strict = 'true'">
	<xsl:text disable-output-escaping="yes">
	//]]&gt;
	</xsl:text>
</xsl:if>
<xsl:text disable-output-escaping="yes">				
&lt;/script&gt;
</xsl:text>
			<xsl:call-template name="addDrillThroughContext">
				<xsl:with-param name="closeScript" select="'yes'"/>
			</xsl:call-template>	
			</xsl:when>
		</xsl:choose>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="addDrillThroughContext">
		<xsl:param name="closeScript"/>
		<xsl:text disable-output-escaping="yes">&lt;script type="text/javascript"&gt;</xsl:text>
		<xsl:if test="$Xhtml='true'">
			<xsl:text disable-output-escaping="yes">
				//&lt;![CDATA[
			</xsl:text>
		</xsl:if>				
		var drillThroughTarget;
		var drillTargets = new Array;
		<xsl:for-each select="/Document/DRILLS/DRILL">
			<xsl:variable name="drillThroughParameters">
				<!--this template will javascript encode the xml string-->
				<xsl:apply-templates select="./*[name()='bus:parameters']" mode="drillTargets"/>
			</xsl:variable>
			<xsl:variable name="objectPaths">
				<!--this template will javascript encode the xml string-->
				<xsl:apply-templates select="./*[name()='bus:objectPaths']" mode="drillTargets"/>
			</xsl:variable>
			<xsl:variable name="parameterProperties">
				<!--this template will javascript encode the xml string-->
				<xsl:apply-templates select="./PARAMETER-PROPERTIES" mode="drillTargets"/>
			</xsl:variable>			
			<xsl:variable name="outputFormat">
				<!--this template will javascript encode the xml string-->
				<xsl:choose>
					<xsl:when test="./@outputFormat">
						<xsl:choose>
							<xsl:when test="./@outputFormat='MHT'">
								<xsl:text>HTML</xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="./@outputFormat"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="/Document/@outputFormat='MHT'">
								<xsl:text>HTML</xsl:text>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="/Document/@outputFormat"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			drillThroughTarget = new CDrillThroughTarget('<xsl:value-of select="rsext:javascriptencode(string(./@label))" disable-output-escaping="yes"/>', '<xsl:value-of select="rsext:javascriptencode(string($outputFormat))" disable-output-escaping="yes"/>', '<xsl:value-of select="rsext:javascriptencode(string(./@outputLocale))" disable-output-escaping="yes"/>', '<xsl:value-of select="rsext:javascriptencode(string(./@showInNewWindow))" disable-output-escaping="yes"/>', '<xsl:value-of select="rsext:javascriptencode(string(./@method))" disable-output-escaping="yes"/>', '<xsl:value-of select="rsext:javascriptencode(string(./@path))" disable-output-escaping="yes"/>', '<xsl:value-of select="rsext:javascriptencode(string(./@bookmarkRef))" disable-output-escaping="yes"/>', '<xsl:value-of select="$drillThroughParameters" disable-output-escaping="yes"/>', '<xsl:value-of select="$objectPaths" disable-output-escaping="yes"/>', '<xsl:value-of select="rsext:javascriptencode(string(./@prompt))" disable-output-escaping="yes"/>', '<xsl:value-of select="rsext:javascriptencode(string(./@sendFilterContext))" disable-output-escaping="yes"/>', '<xsl:value-of select="$parameterProperties" disable-output-escaping="yes"/>'); 
			drillTargets.push(drillThroughTarget);
		</xsl:for-each>
		<xsl:if test="$closeScript='yes'">
		<xsl:if test="$Xhtml='true'">
			<xsl:text disable-output-escaping="yes">
			//]]&gt;
			</xsl:text>
		</xsl:if>
		<xsl:text disable-output-escaping="yes">&lt;/script&gt;</xsl:text>		
		</xsl:if>
	</xsl:template>

	<xsl:template name="getDrillThruBody">
		<xsl:if test="($drillSupport='inline' or $sdkDrillSupport='true') and ($appSupport='false')">
			<xsl:text disable-output-escaping="yes">&lt;form name="multiDrillForm" id="multiDrillForm" method="post" action="</xsl:text><xsl:value-of select="$gatewayPath"/><xsl:text disable-output-escaping="yes">" style="margin:0px"&gt;
&lt;input type="hidden" name="b_action" value="xts.run"/&gt;
&lt;input type="hidden" name="m" value="portal/drillthrough.xts"/&gt;
&lt;input type="hidden" name="ui.action" value=""/&gt;
&lt;input type="hidden" name="ui.object" value=""/&gt;
&lt;input type="hidden" name="run.outputFormat" value=""/&gt;
&lt;input type="hidden" name="run.outputLocale" value=""/&gt;
&lt;input type="hidden" name="ui.bookmark" value=""/&gt;
&lt;input type="hidden" name="run.prompt" value="false"/&gt;
&lt;input type="hidden" name="nh" value="1"/&gt;
&lt;input type="hidden" name="tb" value="0"/&gt;
&lt;input type="hidden" name="drillTargets" value=""/&gt;
&lt;input type="hidden" name="errURL" value="javascript:window.close()"/&gt;
&lt;input type="hidden" name="backURL" value="javascript:window.close()"/&gt;
&lt;input type="hidden" name="dfemail" value="1"/&gt;
&lt;input type="hidden" name="sourceContext" value=""/&gt;
&lt;input type="hidden" name="objectPaths" value=""/&gt;
&lt;/form>
</xsl:text>
		</xsl:if>
	</xsl:template>


	<!-- drillTargets on chart elements
	
	-->
	<xsl:template match="OAREA" priority="1">
		<xsl:if test="./drillTargets">
        <xsl:choose>
			<xsl:when test="$appSupport='true'">
				<xsl:attribute name="drillCtx"><xsl:value-of select="./drillTargets/@drillCtx"/></xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
			<xsl:attribute name="style"><xsl:text>cursor:pointer;cursor:hand;</xsl:text></xsl:attribute>
			<xsl:call-template name="generateDrillThroughEventHandler">
				<xsl:with-param name="node" select="./drillTargets"/>
			</xsl:call-template>		
			</xsl:otherwise>
        </xsl:choose>
		</xsl:if>
	</xsl:template>

	<!--
		drillTargets on Images
	-->
	<xsl:template match="OIMG/drillTargets">
		<!--
			If there is only one drill target, do the work right here and generate the correct URL based on the showInNewWindow attribute
		-->
 		<xsl:if test="$appSupport='false'">
        <xsl:attribute name="style">
            <xsl:for-each select="../@style"><xsl:value-of select="."/>;</xsl:for-each>
            <xsl:text>cursor:pointer;cursor:hand;</xsl:text>
        </xsl:attribute>
        </xsl:if>
        <xsl:choose>
			<xsl:when test="$appSupport='true'">
				<xsl:attribute name="drillCtx"><xsl:value-of select="@drillCtx"/></xsl:attribute>
			</xsl:when>
			<xsl:when test="$interactiveOutput='true' and $sdkDrillSupport='false'">
				<xsl:attribute name="dtTargets">
					<xsl:apply-templates select="*[not(self::OTI)]" mode="drillTargets"/>
				</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="generateDrillThroughEventHandler">
					<xsl:with-param name="node" select="."/>
				</xsl:call-template>
			</xsl:otherwise>
        </xsl:choose>
	</xsl:template>
	<!-- 
		drillTargets on TextItems
	-->
	<xsl:template match="drillTargets">
		<span>
			<xsl:choose>
				<xsl:when test="$appSupport='true'">
					<xsl:attribute name="drillCtx"><xsl:value-of select="@drillCtx"/></xsl:attribute>
				</xsl:when>
				<xsl:when test="$interactiveOutput='true' and $sdkDrillSupport='false'">
					<xsl:attribute name="dtTargets">
					<xsl:apply-templates select="*[not(self::OTI)]" mode="drillTargets"/></xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<!--
						If there is only one drill target, do the work right here and generate the correct URL based on the showInNewWindow attribute
					-->				
					<xsl:attribute name="style"><xsl:text>cursor:pointer;cursor:hand;</xsl:text></xsl:attribute>
					<xsl:call-template name="generateDrillThroughEventHandler">
						<xsl:with-param name="node" select="."/>
					</xsl:call-template>
				</xsl:otherwise>	
			</xsl:choose>
			<xsl:apply-templates select="OTI"/>
		</span>
	</xsl:template>
	
	<xsl:template name="generateDrillThroughEventHandler">
		<xsl:param name="node"/>
		<xsl:choose>
			<xsl:when test="count($node/drillTarget) = 1 and $node/drillTarget/@bookmarkRef != '' and $drillSupport='no'">
				<!-- We only get in this template if there is drill information to be rendered
				     but if drillSupport=no, then we are dealing with a simple bookmark -->
				<xsl:attribute name="onkeypress">if (event.keyCode == 13) {
					<xsl:choose>
						<xsl:when test="$mht='true'">
							<xsl:text>docLocation('</xsl:text>
							<xsl:choose>
								<xsl:when test="$strict = 'true'">
									<xsl:value-of select="rsext:javascriptencode(rsext:replace (rsext:urlencode(string($node/drillTarget/@bookmarkRef)), '+', '-'))"/>
									<xsl:text>'); }</xsl:text>
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="rsext:javascriptencode(rsext:urlencode(string($node/drillTarget/@bookmarkRef)))"/>
									<xsl:text>'); }</xsl:text>
									<xsl:attribute name="tabIndex">0</xsl:attribute>
									<xsl:if test="$accessible='true'">
										<xsl:attribute name="role">link</xsl:attribute>
									</xsl:if>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>document.location='#</xsl:text>
							<xsl:choose>
								<xsl:when test="$strict = 'true'">
									<xsl:value-of select="rsext:javascriptencode(rsext:replace (rsext:urlencode(string($node/drillTarget/@bookmarkRef)), '+', '-'))"/>
									<xsl:text>'; }</xsl:text>									
								</xsl:when>
								<xsl:otherwise>
									<xsl:value-of select="rsext:javascriptencode(rsext:urlencode(string($node/drillTarget/@bookmarkRef)))"/>
									<xsl:text>'; }</xsl:text>
									<xsl:attribute name="tabIndex">0</xsl:attribute>
									<xsl:if test="$accessible='true'">
										<xsl:attribute name="role">link</xsl:attribute>
									</xsl:if>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>				
				<xsl:attribute name="onclick">
					<xsl:choose>
						<xsl:when test="$mht='true'">
							<xsl:text>docLocation('</xsl:text>
							<xsl:choose>
								<xsl:when test="$strict = 'true'">
							<xsl:value-of select="rsext:javascriptencode(rsext:replace (rsext:urlencode(string($node/drillTarget/@bookmarkRef)), '+', '-'))"/>
								</xsl:when>
								<xsl:otherwise>
							<xsl:value-of select="rsext:javascriptencode(rsext:urlencode(string($node/drillTarget/@bookmarkRef)))"/>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:text>')</xsl:text>	
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>document.location='#</xsl:text>
							<xsl:choose>
								<xsl:when test="$strict = 'true'">
							<xsl:value-of select="rsext:javascriptencode(rsext:replace (rsext:urlencode(string($node/drillTarget/@bookmarkRef)), '+', '-'))"/>
								</xsl:when>
								<xsl:otherwise>
							<xsl:value-of select="rsext:javascriptencode(rsext:urlencode(string($node/drillTarget/@bookmarkRef)))"/>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:text>'</xsl:text>	
						</xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="$strict='false'">
					<xsl:attribute name="href"><xsl:text>#</xsl:text></xsl:attribute>
				</xsl:if>
				<xsl:attribute name="onclick">
					<xsl:choose>
						<xsl:when test="count($node/drillTarget) = 1">
							<xsl:text>doSingleDrillThrough( new Array(</xsl:text>	
							<xsl:text>new Array("</xsl:text><xsl:value-of select="$node/drillTarget/@drillIdx"/><xsl:text>")</xsl:text>
							<xsl:call-template name="paramsArray">
								<xsl:with-param name="drillTargetNode" select="$node/drillTarget"/>
							</xsl:call-template>
							<xsl:text>),'</xsl:text>
							<xsl:value-of select="rsext:javascriptencode(string(rsext:urlencode(string($node/drillTarget/@bookmarkRef))))"/>
							<xsl:text>','_THIS_');</xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>doMultipleDrillThrough( new Array(</xsl:text>							
							<xsl:for-each select="$node/drillTarget">
								<xsl:text>new Array("</xsl:text><xsl:value-of select="./@drillIdx"/><xsl:text>","</xsl:text><xsl:value-of select="./@label"/><xsl:text>","</xsl:text><xsl:apply-templates select="./*" mode="drillTargets"/><xsl:text>")</xsl:text>
								<xsl:if test="position() != last()">
									<xsl:text>,</xsl:text>
								</xsl:if>						
							</xsl:for-each>		
							<xsl:text>),'_THIS_');</xsl:text>					
						</xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!--
		Build up the parameters array
	-->
	<xsl:template name="paramsArray">
		<xsl:param name="drillTargetNode"/>

		<xsl:variable name="drillTargetLabel" select="$drillTargetNode/@label"/>
		
		<xsl:for-each select="$drillTargetNode/drillParameter">
			<xsl:choose>
				<xsl:when test="./@value!=''">
				<xsl:variable name="selectChoices">
					<xsl:choose>
						<!--when selectChoices element is passed through, it's has already been xml encoded, so don't double encode it -->
						<xsl:when test="starts-with(normalize-space(string(./@value)), '&lt;selectChoices&gt;')">
							<xsl:value-of select="string(./@value)"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text>&lt;selectChoices&gt;</xsl:text>
							<xsl:text>&lt;selectOption </xsl:text>
							<xsl:text>useValue=&quot;</xsl:text>
							<xsl:value-of select="rsext:xmlencode(string(./@value))"/>
							<xsl:text>&quot; </xsl:text>
							<xsl:if test="./@mun!=''">
								<xsl:text>mun=&quot;</xsl:text>
								<xsl:value-of select="rsext:xmlencode(string(./@mun))"/>
								<xsl:text>&quot; </xsl:text>
							</xsl:if>							
							<xsl:variable name="parameterName" select="@name"/>
							<xsl:if test="/Document/DRILLS/DRILL[@label = string($drillTargetLabel)]/PARAMETER-PROPERTIES/Parameter[@name=string($parameterName)]/@propertyToPass != ''">
								<xsl:text>propertyToPass=&quot;</xsl:text>
								<xsl:value-of select="rsext:xmlencode(string(/Document/DRILLS/DRILL[@label = string($drillTargetLabel)]/PARAMETER-PROPERTIES/Parameter[@name=string($parameterName)]/@propertyToPass))"/>
								<xsl:text>&quot; </xsl:text>
							</xsl:if>
							<xsl:text>displayValue=&quot;</xsl:text>
							<xsl:choose>
								<xsl:when test="./@displayValue"><xsl:value-of select="rsext:xmlencode(string(./@displayValue))"/></xsl:when>
								<xsl:otherwise><xsl:value-of select="rsext:xmlencode(string(./@value))"/></xsl:otherwise>
							</xsl:choose>
							<xsl:text>&quot;/&gt;</xsl:text>
							<xsl:text>&lt;/selectChoices&gt;</xsl:text>							
						</xsl:otherwise>
					</xsl:choose>				
				</xsl:variable>
				<xsl:text>, new Array("p_</xsl:text><xsl:value-of select="rsext:javascriptencode(string(./@name))" disable-output-escaping="yes"/><xsl:text>","</xsl:text><xsl:value-of select="rsext:javascriptencode(string($selectChoices))" disable-output-escaping="yes"/><xsl:text>")</xsl:text>						
				</xsl:when>
				<xsl:otherwise>
					<xsl:variable name="selectChoices">
							<xsl:text>&lt;selectChoices&gt;</xsl:text>
							<xsl:text>&lt;/selectChoices&gt;</xsl:text>							
					</xsl:variable>
					<xsl:text>, new Array("p_</xsl:text><xsl:value-of select="rsext:javascriptencode(string(./@name))" disable-output-escaping="yes"/><xsl:text>","</xsl:text><xsl:value-of select="rsext:javascriptencode(string($selectChoices))" disable-output-escaping="yes"/><xsl:text>")</xsl:text>						
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>

	<xsl:template match="*" mode="drillTargets">
		<xsl:text>&lt;</xsl:text>
		<xsl:value-of select="name()"/>
		<xsl:apply-templates select="@*" mode="drillTargets"/>
		<xsl:if test="local-name()='drillParameter'">
			<xsl:variable name="parameterName" select="@name"/>
			<xsl:variable name="drillTargetLabel" select="../@label"/>
			<xsl:if test="/Document/DRILLS/DRILL[@label = string($drillTargetLabel)]/PARAMETER-PROPERTIES/Parameter[@name=string($parameterName)]/@propertyToPass != ''">
				<xsl:text>&#32;propertyToPass=\"</xsl:text>
				<xsl:value-of select="rsext:xmlencode(string(/Document/DRILLS/DRILL[@label = string($drillTargetLabel)]/PARAMETER-PROPERTIES/Parameter[@name=string($parameterName)]/@propertyToPass))"/>
				<xsl:text>\"</xsl:text>
			</xsl:if>
		</xsl:if>
		<xsl:text>/&gt;</xsl:text>
	</xsl:template>
	<!-- generate text for an element with children or text -->
	<xsl:template match="*[* | text()]" mode="drillTargets">
		<xsl:text>&lt;</xsl:text>
		<xsl:value-of select="name()"/>
		<xsl:apply-templates select="@*" mode="drillTargets"/>
		<xsl:text>&gt;</xsl:text>
		<xsl:apply-templates select="* | text()" mode="drillTargets"/>
		<xsl:text>&lt;\/</xsl:text>
		<xsl:value-of select="name()"/>
		<xsl:text>&gt;</xsl:text>
	</xsl:template>
	<!-- generate text for an attribute -->
	<xsl:template match="@*" mode="drillTargets">
		<xsl:text>&#32;</xsl:text>
		<xsl:value-of select="name()"/>
		<xsl:text>=\"</xsl:text>
		<xsl:value-of select="rsext:javascriptencode(rsext:xmlencode(string(.)))"/>
		<xsl:text>\"</xsl:text>
	</xsl:template>
	<!-- generate text -->
	<xsl:template match="text()" mode="drillTargets">
		<xsl:value-of select="rsext:xmlencode(string(.))"/> 
	</xsl:template>
	<!-- We do not want any of the OTI stuff -->
	<xsl:template match="OTI" mode="drillTargets">
		<!-- do nothing -->
	</xsl:template>

</xsl:stylesheet>
