<?xml version="1.0" encoding="UTF-8"?>
<!--
Licensed Materials - Property of IBM

IBM Cognos Products: rsvp

(C) Copyright IBM Corp. 2005, 2010

US Government Users Restricted Rights - Use, duplication or disclosure 
restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<!-- COPYRIGHT_DATA {'RELEASE': ['2005', '2009', 'colorado_wave1', 'colorado_wave2'], 'VISIBLE': 'YES', 'COMPONENT': 'rsvp'}-->
<!--All lines above the COPYRIGHT_DATA  line will be replaced when copyright notices are generated. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<!--
		The parameters that the report server will possible set
			htmlFragment - generate a fragment (no head or body tags) when 'true'
			Xhtml - generate XHTML when 'true'
			promptSupport - include prompt support when 'true'
			drillSupport - include drill support 'inline', 'yes', 'no'
			sdkDrillSupport - include authored drill support for SDK apps when 'true'
			chartSupport - include chart support when 'true'
			chartSrc - the tag used to select the proper chart path
			reportTitle - the report title
			email - produce email compatible output (self contained) when 'true'
			mht - produce mht compatible output when 'true'
			httpUserAgent - the browser type when available
			gatewayPath - the gateway from the configuration
			basePath - the base path portion of the gateway
			contentLocale - the run locale
			productLocale - the product locale
			skin - the search path for prompt control skins in report output.
			interactiveOutput - the output is being returned in the SOAP response and is
								assumed to be consumed by a browser.
			firstPage - indicates this is the first page of a set making up a single document when 'true'
			lastPage - indicates this is the last page of a set making up a single document when 'true'
			testMode - running in test mode.
			chartEnableTransparencyIE - whether to enable special IE workarounds for chart image transparency
			hyperlinkButtonNewWindow - whether to open hyperlinks in a new window or the same window
			hyperlinkMultipleToolbars - whether to permit multiple toolbars in HTML documents
			encoding - the encoding the output is being produced in.
			pageNumber - the current page number
			strict - whether to generate strict XHTML or not, also includes some accessibility content
			generateContextData
			accessible - enable 'Section 508'-type accessibility on the output
			namespaceID - default value blank, can be overridden as a xslParameter run option.
			appSupport - include application support when 'true'
	-->
	<xsl:param name="htmlFragment">false</xsl:param>
	<xsl:param name="Xhtml">false</xsl:param>
	<xsl:param name="promptSupport">false</xsl:param>
	<xsl:param name="drillSupport">no</xsl:param>
	<xsl:param name="sdkDrillSupport">false</xsl:param>
	<xsl:param name="chartSupport">false</xsl:param>
	<xsl:param name="chartSrc">src</xsl:param>
	<xsl:param name="reportTitle"></xsl:param>
	<xsl:param name="email">false</xsl:param>
	<xsl:param name="mht">false</xsl:param>
	<xsl:param name="httpUserAgent"></xsl:param>
	<xsl:param name="gatewayPath"></xsl:param>
	<xsl:param name="basePath"></xsl:param>
	<xsl:param name="contentLocale">en-us</xsl:param>
	<xsl:param name="productLocale">en-us</xsl:param>
	<xsl:param name="contentLanguage">en</xsl:param>
	<xsl:param name="skin">../prompting/reportskin</xsl:param>
	<xsl:param name="interactiveOutput">false</xsl:param>
	<xsl:param name="firstPage">true</xsl:param>
	<xsl:param name="lastPage">true</xsl:param>
	<xsl:param name="testMode">false</xsl:param>
	<xsl:param name="chartEnableTransparencyIE">true</xsl:param>
	<xsl:param name="hyperlinkButtonNewWindow">true</xsl:param>
	<xsl:param name="hyperlinkMultipleToolbars">true</xsl:param>
	<xsl:param name="encoding">utf-8</xsl:param>
	<xsl:param name="pageNumber">1</xsl:param>
	<xsl:param name="strict">false</xsl:param>
	<xsl:param name="generateContextData">false</xsl:param>
	<xsl:param name="accessible">false</xsl:param>
	<xsl:param name="namespaceID">" "</xsl:param>
	<xsl:param name="appSupport">false</xsl:param>
	

	<!-- 
		The followings are global parameters and variables required for the XSLT transformations but NOT set by RSVP.
	-->
	<!-- Root folder for JavaScript and CSS files. -->
	<xsl:param name="webRoot">..</xsl:param>
	<!-- Browser detection variables. -->
	<xsl:variable name="isIE"   select="contains($httpUserAgent, 'MSIE')"/>
	<xsl:variable name="isIE5"  select="contains($httpUserAgent, 'MSIE 5.0')"/>
	<xsl:variable name="isIE55" select="contains($httpUserAgent, 'MSIE 5.5')"/>
	<xsl:variable name="isIE6"  select="contains($httpUserAgent, 'MSIE 6')"/>
	<xsl:variable name="isNS6"  select="contains($httpUserAgent, 'Mozilla/5') and (contains($httpUserAgent, 'Gecko') or contains($httpUserAgent, 'Netscape'))"/>
	
</xsl:stylesheet>
