<?xml version="1.0" encoding="UTF-8"?>
<!--
Licensed Materials - Property of IBM

IBM Cognos Products: rsvp

(C) Copyright IBM Corp. 2005, 2010

US Government Users Restricted Rights - Use, duplication or disclosure 
restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<!-- COPYRIGHT_DATA {'RELEASE': ['2005', '2009', 'colorado_wave1', 'colorado_wave2'], 'VISIBLE': 'YES', 'COMPONENT': 'rsvp'}-->
<!--All lines above the COPYRIGHT_DATA  line will be replaced when copyright notices are generated. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  xmlns:rsext="xalan://com.cognos.reportserver.ext.RSExt" version="1.0">
	<xsl:include href="V5environment.xsl"/>
	<xsl:include href="V5ReportEngine.xsl"/>
	<xsl:include href="V5drillthru.xsl"/>
	<xsl:include href="../../ps/prompting/p_include.xsl"/>
	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="no"/>
	<xsl:variable name="promptLocale" select="$contentLocale"/>
	<xsl:variable name="promptFormName" select="'formWarpRequest'"/>

	<xsl:variable name="sGenerateContextData">
		<xsl:choose>
<!--			<xsl:when test="//META-DATA[@contextItemFormat='InitializerFormat'] and $strict='false'">true</xsl:when> -->
			<xsl:when test="$generateContextData = 'true' and $strict='false'">true</xsl:when> 
			<xsl:otherwise>false</xsl:otherwise>
		</xsl:choose> 
	</xsl:variable>

	<!--
        template : /Document
    -->
	<xsl:template match="/Document">
		<xsl:choose>
			<xsl:when test="$htmlFragment='true'">
				<xsl:if test="$firstPage='true'">
					<xsl:text disable-output-escaping="yes">&lt;!--
Licensed Materials - Property of IBM

IBM Cognos Products: rsvp

(C) Copyright IBM Corp. 2005, 2010

US Government Users Restricted Rights - Use, duplication or disclosure 
restricted by GSA ADP Schedule Contract with IBM Corp.
--&gt;
</xsl:text>
					<xsl:text disable-output-escaping="yes">&lt;!--</xsl:text>
					<xsl:apply-templates select="/Document/styleOptions"/>
					<xsl:text disable-output-escaping="yes"> --&gt;
</xsl:text>
					<xsl:call-template name="chartConfig"/>
					<xsl:call-template name="textAlignForFireFox"/>
				</xsl:if>
				<xsl:apply-templates select="DATA"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="$firstPage='true'">
					<xsl:choose>
						<xsl:when test="$Xhtml='true'">
						<xsl:if test="$appSupport='false'">
							<xsl:text disable-output-escaping="yes">&lt;!DOCTYPE html SYSTEM "</xsl:text>
							<xsl:value-of select="$basePath"/>
							<xsl:text disable-output-escaping="yes">../dtds/entities.dtd"&gt;
</xsl:text>
</xsl:if>
<xsl:choose>
	<xsl:when test="$strict='true'">
<xsl:text disable-output-escaping="yes">&lt;html xmlns="http://www.w3.org/1999/xhtml" lang="</xsl:text><xsl:value-of select="$contentLanguage"/><xsl:text disable-output-escaping="yes">" xml:lang="</xsl:text><xsl:value-of select="$contentLanguage"/><xsl:text disable-output-escaping="yes">" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
xsi:schemaLocation="http://www.w3.org/1999/xhtml </xsl:text>
<xsl:text disable-output-escaping="yes">../dtds/xhtml1-strict.xsd"&gt;
</xsl:text>
</xsl:when>
<xsl:otherwise>
<xsl:text disable-output-escaping="yes">
&lt;html lang="</xsl:text><xsl:value-of select="$contentLanguage"/><xsl:text disable-output-escaping="yes">"&gt;
</xsl:text>
</xsl:otherwise>							
</xsl:choose>							
<xsl:text disable-output-escaping="yes">&lt;head&gt;</xsl:text>
		<xsl:if test="$appSupport='false'">
<xsl:text disable-output-escaping="yes">
&lt;meta http-equiv="Content-Type" content="text/html; charset=</xsl:text><xsl:value-of select="$encoding" disable-output-escaping="yes"/><xsl:text disable-output-escaping="yes">"/&gt;
&lt;meta name="Copyright" content="Licensed Materials - Property of IBM; IBM Cognos Products: rsvp; (C) Copyright IBM Corp. 2005, 2010; US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp."/&gt;

</xsl:text>
		</xsl:if>
						</xsl:when>
						<xsl:otherwise>
							<xsl:text disable-output-escaping="yes">&lt;html lang="</xsl:text><xsl:value-of select="$contentLanguage"/><xsl:text disable-output-escaping="yes">"&gt;
&lt;head&gt;</xsl:text>
		<xsl:if test="$appSupport='false'">
<xsl:text disable-output-escaping="yes">
&lt;meta http-equiv="Content-Type" content="text/html; charset=</xsl:text><xsl:value-of select="$encoding" disable-output-escaping="yes"/><xsl:text disable-output-escaping="yes">"&gt;
&lt;meta name="Copyright" content="Licensed Materials - Property of IBM; IBM Cognos Products: rsvp; (C) Copyright IBM Corp. 2005, 2010; US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp."&gt;
</xsl:text>
		</xsl:if>
						</xsl:otherwise>
					</xsl:choose>
					<!-- If generating HTML and XHTML, include the QS Viewer selection UI styles link (not applicable for fragments) -->
					<xsl:if test="$sGenerateContextData='true' and $appSupport='false'">
						<link rel="stylesheet" type="text/css" href="../skins/corporate/viewer/QSRVSelection.css"/>
					</xsl:if>
					<xsl:apply-templates select="/Document/styleOptions"/>

					<!-- Can't leave a empty title tag, XSLT will optimise it to <title/> and IE6.0 won't recognise it as a end tag, so all the rest of the document becomes the title and you get a blank page... -->
					<xsl:text disable-output-escaping="yes">
&lt;title&gt;</xsl:text>
					<xsl:value-of select="$reportTitle" disable-output-escaping="yes"/>
					<xsl:text disable-output-escaping="yes">&lt;/title&gt;
</xsl:text>
					<xsl:if test="$mht='true' and $appSupport='false'">
						<xsl:choose>
							<xsl:when test="$strict='true'">
						<xsl:text disable-output-escaping="yes">&lt;script type="text/javascript"&gt;
</xsl:text>
							</xsl:when>
							<xsl:otherwise>
						<xsl:text disable-output-escaping="yes">&lt;script language="javascript" type="text/javascript"&gt;
</xsl:text>
							</xsl:otherwise>
						</xsl:choose>
					<xsl:if test="$Xhtml='true'">
						<xsl:text disable-output-escaping="yes">//&lt;![CDATA[
</xsl:text>
					</xsl:if>			
					<xsl:text disable-output-escaping="yes">function docLocation(label)
{
	if (navigator.userAgent.indexOf('MSIE') != -1)
		label="mhtml:#"+label;
	else
		label="#"+label;
	document.location=label;
}
</xsl:text>
					<xsl:if test="$Xhtml='true'">
						<xsl:text disable-output-escaping="yes">//]]&gt;
</xsl:text>
					</xsl:if>
					<xsl:text disable-output-escaping="yes">&lt;/script&gt;
</xsl:text>
					</xsl:if>
					<xsl:if test="$promptSupport='true'">
						<!-- Add prompt control javascript and style sheets -->
						<xsl:call-template name="getPromptHeadIncludes">
							<xsl:with-param name="promptLocale" select="$productLocale"/>
							<xsl:with-param name="promptContentLocale" select="$contentLocale"/>
						</xsl:call-template>
					</xsl:if>
					
					<xsl:if test="$drillSupport!='no'">
						<xsl:call-template name="getDrillThruHead"/>
					</xsl:if>
					<xsl:call-template name="chartConfig"/>
					<xsl:call-template name="parentViewerScript"/>					
					<xsl:call-template name="textAlignForFireFox"/>
					<xsl:text disable-output-escaping="yes">
&lt;/head&gt;
&lt;body </xsl:text>
				<xsl:if test="$accessible='true'">
					<xsl:text disable-output-escaping="yes">role="application" </xsl:text>
				</xsl:if>
				<!-- render the body tag and attributes -->
				<xsl:if test="$appSupport='false'">
				<xsl:choose>
					<xsl:when test="$strict='true'">
					<xsl:text disable-output-escaping="yes">
onclick="if(parent &amp;amp;&amp;amp; typeof parent.oCV_THIS_ == 'object') parent.oCV_THIS_.rvMainWnd.pageClicked(event);" </xsl:text>
					</xsl:when>
					<xsl:otherwise>
					<xsl:text disable-output-escaping="yes">
onclick="onClickEvent(event);" </xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="$sGenerateContextData='true'">
				<xsl:text disable-output-escaping="yes">onkeydown="onKeyDownEvent(event);" </xsl:text>
					<!-- generate the options on the body (which include interactive events when initializer format context is present) -->
					<xsl:text disable-output-escaping="yes">onload="onLoadEvent(event);" onmousemove="onMouseMoveEvent(event);" ondblclick="onDoubleClickEvent(event);" oncontextmenu="onContextMenuEvent(event);"</xsl:text>
				</xsl:if>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="$strict='true'">
				<xsl:text  disable-output-escaping="yes"> style="margin-top:0px;margin-left:0px;background-color: #FFFFFF;"&gt;
</xsl:text>
					</xsl:when>
					<xsl:otherwise>
				<xsl:text  disable-output-escaping="yes">topmargin="0" leftmargin="0" style="background-color: #FFFFFF;"&gt;
</xsl:text>
					</xsl:otherwise>
				</xsl:choose>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="$promptSupport='false'">
						<xsl:apply-templates select="DATA"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:if test="$firstPage='true'">
							<xsl:choose>
								<xsl:when test="$strict = 'true'">
							<xsl:text disable-output-escaping="yes">&lt;form name="formWarpRequest" id="formWarpRequest" method="post" style="margin:0px" onsubmit="if((typeof promptButtonOK).match(/^function$/i)){promptButtonOK();return false;} else if((typeof execute).match(/^function$/i)){execute();return false;}"&gt;
</xsl:text>
								</xsl:when>
								<xsl:otherwise>
							<xsl:text disable-output-escaping="yes">&lt;FORM NAME="formWarpRequest" ID="formWarpRequest" METHOD="POST" style="margin:0px" onsubmit="if((typeof promptButtonOK).match(/^function$/i)){promptButtonOK();return false;} else if((typeof execute).match(/^function$/i)){execute();return false;}"&gt;
</xsl:text>
								</xsl:otherwise>
							</xsl:choose>
							<xsl:if test="not(optionList/userData/@name='b_action')">
								<xsl:text disable-output-escaping="yes">&lt;input type="hidden" name="b_action" value="xts.run"/&gt;
</xsl:text>
							</xsl:if>
							<xsl:if test="not(optionList/userData/@name='m')">
								<xsl:text disable-output-escaping="yes">&lt;input type="hidden" name="m" value="async/conv.xts"/&gt;
</xsl:text>
							</xsl:if>
							<xsl:if test="not(optionList/userData/@name='ui.action')">
								<xsl:text disable-output-escaping="yes">&lt;input type="hidden" name="ui.action" value="forward"/&gt;
</xsl:text>
							</xsl:if>
							<xsl:apply-templates select="optionList/userData[./@name!='ui.spec' or ./@name!='ui.conversation' or ./@name!='ui.object']"/>
							<xsl:text disable-output-escaping="yes">&lt;input type="hidden" name="ui.object" value=""/&gt;
&lt;input type="hidden" name="ui.spec" value=""/&gt;
&lt;input type="hidden" name="ui.conversation" value=""/&gt;
&lt;input type="hidden" name="run.prompt" value=""/&gt;
</xsl:text>
						</xsl:if>
						<xsl:apply-templates select="DATA"/>
						<xsl:if test="$lastPage='true'">
							<xsl:text disable-output-escaping="yes">
&lt;/FORM&gt;
</xsl:text>
						</xsl:if>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:if test="$lastPage='true'">
					<xsl:call-template name="getDrillThruBody"/>
					<xsl:text disable-output-escaping="yes">
&lt;/body&gt;
&lt;/html&gt;
</xsl:text>
				</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- userData nodes that are prefixed with either an _ or a p_ (prompt values) will not be round-tripped -->
	<!-- <xsl:template match="userData">
		<xsl:if test="substring(@name,1,1)!='_'">
			<xsl:if test="substring(@name,1,2)!='p_'">
				<xsl:text disable-output-escaping="yes">
&lt;INPUT TYPE="HIDDEN" NAME="</xsl:text>
{@name}<xsl:text disable-output-escaping="yes">" VALUE="</xsl:text>
{@value}<xsl:text disable-output-escaping="yes">"/&gt;
</xsl:text>
			</xsl:if>
		</xsl:if>
	</xsl:template>-->

	<!--
		The following templates are only required by Query Studio but since they are called from generic XSL code,
		they are defined here as empty templates.
	-->

	<xsl:template name="parentViewerScript">
		<xsl:if test="$appSupport='false'">
		<script type="text/javascript">
			var gCognosViewerId = "_THIS_";
			var sLocation = document.location.search;
			if (sLocation.match(/cv\.id=([^&amp;?]*)/))
			{
				gCognosViewerId = RegExp.$1;
			}
			
			function getCognosViewer()
			{
				var cognosViewer = null;
				try
				{
					cognosViewer = eval("parent.oCV" + gCognosViewerId);
				}
				catch(e)
				{
					cognosViewer = null; 
				}
				
				return cognosViewer;
			}
			
			<xsl:if test="$sGenerateContextData='true'">
				function getSelectionController()
				{
					var selectionController = null;
					
					var cognosViewer = getCognosViewer();
					if(cognosViewer != null)
					{
						selectionController = cognosViewer.getSelectionController();
					}
					
					return selectionController;
				};
			
			
				function onLoadEvent(evt)
				{
					<xsl:variable name="metaData">
						<xsl:value-of select="string(/Document/META-DATA/Block)" disable-output-escaping="yes"/>
					</xsl:variable>
					<xsl:variable name="contextData">
						<xsl:value-of select="string(/Document/CONTEXT-DATA/Block)" disable-output-escaping="yes"/>
					</xsl:variable>
					var selectionController = getSelectionController();
					if(selectionController != null)
					{
						selectionController.addMetaData(<xsl:value-of select="$metaData"/>); 
						selectionController.addContextData(<xsl:value-of select="$contextData"/>); 
						selectionController.setSelectionBasedFeaturesEnabled(true);		
					}
					else {
						setTimeout(onLoadEvent, 100);
					}
				};
				
				function onMouseMoveEvent(evt)
				{
					var selectionController = getSelectionController();
					if(selectionController != null)
					{
						selectionController.pageHover(evt);	
					}
				};
				
				function onKeyDownEvent(evt)
				{
					var cognosViewer = getCognosViewer();
					if(cognosViewer != null)
					{
						cognosViewer.onKeyDown(evt);
					}		
				};
				
				function onDoubleClickEvent(evt)
				{
					var selectionController = getSelectionController();
					if(selectionController != null)
					{
						selectionController.pageDoubleClicked(evt);
					}		
				};
				
				function onContextMenuEvent(evt)
				{				
					var cognosViewer = getCognosViewer();
					if(cognosViewer != null)
					{
						cognosViewer.dcm(evt,true);	
					}	
				};
			
				function preSelectNode(evt)
				{
					if (document.all) 
					{
						var cognosViewer = getCognosViewer();
						if(cognosViewer != null)
						{
							cognosViewer.pcc(evt);	
						}	
					}
				}
			
			</xsl:if>	
			function onClickEvent(evt)
			{
				var cognosViewer = getCognosViewer();
				if(cognosViewer &amp;&amp; cognosViewer.rvMainWnd)
				{
					cognosViewer.rvMainWnd.pageClicked(evt);
				}		
			};
			
		</script>
		</xsl:if>
	</xsl:template>
	<xsl:template name="startPage"/>
	<!-- used in selection -->
	<xsl:template name="GenEventHandlers">
		<xsl:if test="$sGenerateContextData='true'">
			<xsl:if test="@layoutClass='listColumnBody' or @layoutClass='listColumnTitle' or @layoutClass='rowCell' or @layoutClass='crosstabFactCell' or @layoutClass='crosstabNodeMember' or @layoutClass='crosstabCorner' or @layoutClass='repeaterTableCell' or name()='OCHART'">
				<xsl:if test="@cid != ''">
					<xsl:attribute name="cid"><xsl:value-of select="@cid"/></xsl:attribute>
				</xsl:if>
				<xsl:if test="@uid != ''">
					<xsl:attribute name="uid"><xsl:value-of select="@uid"/></xsl:attribute>
					<xsl:attribute name="name">c_THIS_<xsl:value-of select="@uid"/></xsl:attribute>
				</xsl:if>
				<xsl:if test="@ctx != ''">
					<xsl:attribute name="ctx"><xsl:value-of select="@ctx"/></xsl:attribute>
				</xsl:if>
				<xsl:if test="@type != ''">
					<xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
				</xsl:if>
				<xsl:if test="@class">
					<xsl:attribute name="class">c_THIS_<xsl:value-of select="@uid"/>
						<xsl:text> </xsl:text><xsl:value-of select="@class"/>						
						<xsl:if test="@styleId and $vUseStyleId='true'">
							<xsl:text> </xsl:text><xsl:value-of select="@styleId"/>
						</xsl:if>
					</xsl:attribute>
				</xsl:if> 	
			</xsl:if>
		</xsl:if>
		<xsl:if test="name() = 'OCHART'">
			<xsl:if test="$sGenerateContextData='true'">
				<xsl:attribute name="rsvpChart">true</xsl:attribute>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	<!-- used to add events to the main page for selection -->
	<xsl:template match="*[@layoutClass='textItem']" priority="1">
			<span>
				<xsl:call-template name="GenTabIndexAttribute"/>
				<xsl:call-template name="AddAccessibleTagsForSpan"/>
				<xsl:if test="$sGenerateContextData='true'">
					<xsl:if test="@ctx != ''">
						<xsl:attribute name="ctx"><xsl:value-of select="@ctx"/></xsl:attribute>
					</xsl:if>
				</xsl:if>
				<xsl:call-template name="GenCommonAttributes"/>
				<xsl:value-of select="rsext:htmlencode(string(.))" disable-output-escaping="yes"/>
			</span>
	</xsl:template>
	<xsl:template match="OAREA" priority="2">
		<xsl:if test="./MEMBER or ./drillTargets or ./MEASURE">
			<xsl:if test="./MEMBER or ./MEASURE">
				<xsl:attribute name="ctx"><xsl:value-of select="./@ctx"/></xsl:attribute>
					</xsl:if>
			<xsl:choose>
				<xsl:when test="./@type='legendTitle'">
					<xsl:attribute name="isChartTitle">true</xsl:attribute>
				</xsl:when>
			</xsl:choose>
			<xsl:choose>
				<xsl:when test="./@type='ordinalAxisTitle'">
					<xsl:attribute name="isChartTitle">true</xsl:attribute>
				</xsl:when>
			</xsl:choose>
			<xsl:if test="$appSupport='false'">
				<xsl:attribute name="onmouseup"><xsl:text>preSelectNode(event);</xsl:text></xsl:attribute>
			</xsl:if>
			<xsl:if test="./drillTargets">
				<xsl:choose>
					<xsl:when test="$appSupport='true'">
						<xsl:attribute name="drillCtx"><xsl:value-of select="./drillTargets/@drillCtx"/></xsl:attribute>
					</xsl:when>
					<xsl:when test="count(./drillTargets/drillTarget) = 1 and ./drillTargets/drillTarget/@bookmarkRef != '' and $drillSupport='no'">
						<!-- We only get in this template if there is drill information to be rendered
							 but if drillSupport=no, then we are dealing with a simple bookmark -->
						<xsl:attribute name="href">
							<xsl:text disable-output-escaping="yes">#</xsl:text>
							<xsl:value-of select="rsext:urlencode(string(./drillTargets/drillTarget/@bookmarkRef))"/>
						</xsl:attribute>
					</xsl:when>
					<xsl:otherwise>
						<xsl:attribute name="style"><xsl:text>cursor:pointer;cursor:hand;</xsl:text></xsl:attribute>
						<xsl:call-template name="generateDrillThroughEventHandler">
							<xsl:with-param name="node" select="./drillTargets"/>
						</xsl:call-template>		
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>
