<?xml version="1.0" encoding="UTF-8"?>
<!--
  Licensed Materials - Property of IBM
  IBM Cognos Products: Viewer
  (C) Copyright IBM Corp. 2001, 2010

  US Government Users Restricted Rights - Use, duplication or
  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:rsext="xalan://com.cognos.reportserver.ext.RSExt" version="1.0" exclude-result-prefixes="xsl rsext">
	<xsl:include href="V5environment.xsl"/>
	<xsl:include href="V5ReportEngine.xsl"/>

	<!-- Include needed for prompting -->
	<xsl:include href="../../ps/prompting/p_include.xsl"/>

	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="no"/>

	<xsl:variable name="promptLocale" select="$contentLocale"/>
	<xsl:variable name="promptFormName" select="'formWarpRequest'"/>

	<xsl:template match="/Document">
			<script type="text/javascript" src="{$webRoot}/prompting/CDispatcher.js">//</script>

			<!-- Add prompt control javascript and style sheets -->
			<xsl:call-template name="getPromptHeadIncludes">
				<xsl:with-param name="promptLocale" select="$promptLocale"/>
				<xsl:with-param name="promptContentLocale" select="$contentLocale"/>
			</xsl:call-template>

			<xsl:apply-templates select="/Document/styleOptions"/>

			<xsl:apply-templates select="DATA"/>
	</xsl:template>

	<!-- only run these in Query Studio -->
	<xsl:template name="startPage"/>
	<xsl:template name="dropIndicators"/>

	<!-- used in selection -->
	<xsl:template name="GenEventHandlers"/>

</xsl:stylesheet>
