<!--
  Licensed Materials - Property of IBM
  IBM Cognos Products: Viewer
  (C) Copyright IBM Corp. 2001, 2010

  US Government Users Restricted Rights - Use, duplication or
  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xts="http://developer.cognos.com/schemas/xts/" xmlns:encodingUtils="com.cognos.portal.utils.EncodingUtils" exclude-result-prefixes="xts encodingUtils">
	<xsl:output method="html" version="1.0" encoding="UTF-8" indent="no"/>

	<xsl:template match="/">
		<xsl:variable name="customs" select="/root/customs/param"/>
		<xsl:variable name="interactions" select="/root/interactions/param"/>

		<xsl:variable name="reportSpec">
				<xsl:value-of select="$interactions[@name='ui.spec']"/>
		</xsl:variable>
		<xsl:variable name="selectionId">
			<xsl:choose>
				<xsl:when test="$interactions[@name='obj_id']">
					<xsl:value-of select="$interactions[@name='obj_id']"/>
				</xsl:when>
				<xsl:when test="$customs[@name='navSelectionId']">
					<xsl:value-of select="$customs[@name='navSelectionId']"/>
				</xsl:when>
			</xsl:choose>
		</xsl:variable>
		<script type="text/javascript">
			function _THIS_cancelReportViewerFragmentTitleChange(evt)
			{
				if (evt.eventPhase == evt.AT_TARGET){
					evt.stopPropagation();
				}
			}
			_THIS_.addEventListener("fragment.title.change", "_THIS_cancelReportViewerFragmentTitleChange", false);
			_THIS_.addEventListener("*", fragment.prototype.proxyEvent, false);
		</script>
				<table id="_THIS_default" border="0" cellspacing="0" cellpadding="0" width="100%">
					<xsl:if test="string($selectionId) != '' or string($reportSpec) != ''">
						<xsl:attribute name="style">display: none</xsl:attribute>
					</xsl:if>
					<tr>
						<td class="portlet-font" align="center" valign="middle" height="100">
							<xts:string id="IDS_VEW_READY_FOR_REQUESTS"/>
						</td>
					</tr>
				</table>
				<div id="_THIS_rvCanvascontent">
					<xsl:choose>
						<xsl:when test="string($selectionId) = ''  and string($reportSpec) = ''">
							<xsl:attribute name="style">display: none</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="style">height: 100%</xsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:text>_THIS?frag-subfragment=rvCanvas&amp;frag-id=rvCanvas/THIS_</xsl:text>
				</div>
	</xsl:template>
</xsl:stylesheet>
