## Licensed Materials - Property of IBM
## IBM Cognos Products: disp
## (C) Copyright IBM Corp. 2005 2010
## US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

##
## cm.py
##
## This sample script implements simple commands that demonstrate how to access 
## internal Content Manager objects via the Jython interface.
##
## This script must be named cm.py and be located in the <jython>/lib directory.
##
## Use a telnet client to access this script:
##   telnet localhost 9999
##
## then load the script: 
##   import cm
##
## Commands available:
##   cm.version() - displays the version of the CM
##   cm.info()    - shows general information about the CM
##

def help():
  print "CM commands: "
  print "   cm.info()        - shows general information about CM"
  print "   cm.version()     - displays the CM version"
  print ""
  print "Jython commands: "
  print "   reload(cm)       - Reloads the cm.py script from disk (after being edited)"
  print "   dir(cm)          - Lists all commands available in this script"
  print ""

def version():
  from com.cognos.cm import cmInfo
  print "CM version: " + cmInfo.getVersion()

def info():
  from com.cognos.cm import cmInfo
  from com.cognos.cm.server import CMServlet
  cfg = CMServlet.config_
  print "Product name:   " + cmInfo.getProductName()
  print "Component name: " + cmInfo.getComponentName()
  print "CM version:     " + cmInfo.getVersion()
  print "Store version:  " + cmInfo.getStoreVersion()
  print "CM state:       " + _getRunningState()
  print "Web Page Time:  " + CMServlet.getCurrentWebPageTimeString()
  print "Deployment dir: " + cfg.getDeploymentFolder()
  print "Temporary dir:  " + CMServlet.getTempDirectory()
  print "Server errors:  " + str(CMServlet.serverErrorCount_)
  print "DB connection:  " + cfg.getDatabaseConnect()
  
def _getRunningState():
  from com.cognos.cm.server import CMServlet
  if CMServlet.CMRunningMode_ == CMServlet.NOT_RUNNING:
    return "not running"
  if CMServlet.CMRunningMode_ == CMServlet.RUNNING:
    return "running"
  if CMServlet.CMRunningMode_ == CMServlet.STAND_BY_MODE:
    return "standby"

