/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */
/**
	Contains function specific to Cognos Viewer managers.
*/
function CViewerHelper()
{
	this.m_oCV = null;
}

/**
	@type string
	@return Reference (name of the javascript variable) for the CCognosViewer object associated to this helper
*/
CViewerHelper.prototype.getCVObjectRef = function()
{
	return this.getCV().getObjectId();
};

/**
	@type CCognosViewer
	@return CCognosViewer object associated to this helper
*/
CViewerHelper.prototype.getCV = function()
{
	if (this.m_oCV)
	{
		return this.m_oCV;
	}
	return window;
};

/**
	@type string
	@return Id of the CCognosViewer object associated to this helper
*/
CViewerHelper.prototype.getCVId = function()
{
	var sId = "";
	if (this.m_oCV) {
		sId = this.m_oCV.getId();
	}
	return sId;
};

/**
	@param {CCognosViewer} oCV CCognosViewer object associated to this helper
*/
CViewerHelper.prototype.setCV = function(oCV)
{
	this.m_oCV = oCV;
};

