/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */
//take an input string and convert it into
//xml friendly entity references
function sXmlEncode(sInputString)
{
	var sOutputString = "" + sInputString;

	if ((sOutputString == '0') || ((sInputString != null) && (sInputString != false)))
	{
		//&amp;
		sOutputString = sOutputString.replace(/&/g, "&amp;");
		//&lt;
		sOutputString = sOutputString.replace(/</g, "&lt;");
		//&gt;
		sOutputString = sOutputString.replace(/>/g, "&gt;");
		//&quot;
		sOutputString = sOutputString.replace(/"/g, "&quot;");
		//&apos;
		sOutputString = sOutputString.replace(/'/g, "&apos;");
	}

	else if (sInputString == null)
	{
		//return empty string if the value is null or false
		sOutputString = "";
	}

	return sOutputString;
}


//take an xml friendly string and convert it into
//a js friendly string
function sXmlDecodeParser(sAll, sGroup1)
{
	var sRetval = sAll;
	switch(sGroup1)
	{
		case 'amp': sRetval = '&'; break;
		case 'lt': sRetval = '<'; break;
		case 'gt': sRetval = '>'; break;
		case 'quot': sRetval = '"'; break;
		case 'apos': sRetval = "'"; break;
	}
	return sRetval;
}

function sXmlDecode(sInputString)
{
	var sOutputString = "" + sInputString;

	if ((sOutputString == '0') || ((sInputString != null) && (sInputString != false)))
	{
		sOutputString = sOutputString.replace(/&(amp|lt|gt|quot|apos);/g, sXmlDecodeParser);
	}
	else if (sInputString == null)
	{
		//return empty string if the value is null or false
		sOutputString = "";
	}

	return sOutputString;
}
