// Licensed Materials - Property of IBM
// IBM Cognos Products: XQE
// (C) Copyright IBM Corp. 2008, 2010
// US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

function submitadminform(formObj) 
{ 
	if (formObj) 
	{
		formObj.mode.value = 'flush';
   
		formObj.submit();
     
	}
}


function resetadminform(formObj, resetValue) 
{   
	if (formObj) 
	{

		formObj.mode.value = 'reset';

		formObj.xqeMetric_resetfield.value = resetValue;
       
		formObj.submit();
      
	}
}

function reloadadminform(formObj) 
{   
	if (formObj) 
	{

		formObj.dispatcher.value = formObj.xqeConfiguration_dispatchers.options[formObj.xqeConfiguration_dispatchers.selectedIndex].value;		
		formObj.configurationcategory.value = formObj.xqeConfiguration_ConfigCategory.value;   		
		formObj.mode.value = 'reload';
       
		formObj.submit();
      
	}
}

function flushsaladminform(formObj) 
{   
	if (formObj) 
	{

		formObj.mode.value = 'flush';

		formObj.submit();
      
	}
}

function dumpsaladminform(formObj) 
{   
	if (formObj) 
	{

		formObj.mode.value = 'dump';

		formObj.submit();
      
	}
}

function hideAndShow(formObj, rowId, hideOrShow)
{
	if (formObj) {
		var row = document.getElementById(rowId);
		if ((hideOrShow == 'hide'))
		{
			row.style.display = 'none';
		} else {
			row.style.display = '';
		}
	}
}

function changeServerGroup(formObj)
{
    var newServerGroup = formObj.xqeConfiguration_serverGroups.options[formObj.xqeConfiguration_serverGroups.selectedIndex].value;
    formObj.servergroup.value = newServerGroup;
    
    formObj.mode.value = 'display';   
    
    formObj.submit();
}


function changeConfigurationSubCategory(formObj, categoryName, activePage)
{
    formObj.configurationcategory.value = categoryName;    
    formObj.xqeConfiguration_ConfigCategory.value = categoryName;   
    
    formObj.dispatcher.value = activePage;   

    formObj.mode.value = 'display';
    
    formObj.submit(); 
}

function allowNumbersOnly(data, e, dec)
{

var key_null = 0;
var key_backspace = 8;
var key_tab = 9;

var key;
var keychar;

if (window.event)
   key = window.event.keyCode;
else if (e)
   key = e.which;
else
   return true;

keychar = String.fromCharCode(key);

if ( (key==null) || (key==key_null) || (key==key_backspace) || 
    (key==key_tab) )
   return true;
      

else if ((("0123456789").indexOf(keychar) > -1))
   return true;

else if (dec && (keychar == ".")) {
   data.form.elements[dec].focus();
   return false;
}
else
   return false;
}


function submitQSATDS(formObj) 
{ 
	formObj.mode.value = 'dataSource';
	formObj.submit();
}


function submitQSATCatalogs(formObj) 
{ 
	formObj.mode.value = 'catalog';
	formObj.submit();
}


function submitQSATCubesOrOoperation(formObj) 
{ 
	formObj.mode.value = 'cube';
	formObj.submit();
}

function flushadminform(formObj) 
{
	var numberOfCheckBoxChecked = 0;
	if (formObj) 
	{

		var elementCount = formObj.length;
		for(var i = 0; i < elementCount; i++) 
		{
			var element = formObj.elements[i];
			if (element.type == 'checkbox' && element.checked) {
				numberOfCheckBoxChecked++;		
			}
		}
	
		if (numberOfCheckBoxChecked == 0)
		{
			javascript:alert('Choose an entry on which to perform the caching operation by selecting the check box for the entry. ');
		}
		else
		{
			formObj.mode.value = 'flush';
   
			formObj.submit();
		}		
     
	}
}

function dumpadminform(formObj) 
{ 
	var numberOfCheckBoxChecked = 0;
	if (formObj) 
	{
	
		var elementCount = formObj.length;
		for(var i = 0; i < elementCount; i++) 
		{
			var element = formObj.elements[i];
			if (element.type == 'checkbox' && element.checked) {
				numberOfCheckBoxChecked++;		
			}
		}
	
		if (numberOfCheckBoxChecked == 0)
		{
			javascript:alert('Choose an entry on which to perform the caching operation by selecting the check box for the entry. ');
		}
		else
		{
	
			formObj.mode.value = 'dump';
   
			formObj.submit();
		}
     
	}
}


function toggleChecks(formObj, prefix, checkState) 
{
	if (formObj) 
	{
		var elementCount = formObj.length;
		for(var i = 0; i < elementCount; i++) 
		{
			var element = formObj.elements[i];
			if (element.type == 'checkbox' && element.name.indexOf(prefix) == 0) {
				element.checked = checkState;
			}
		}
	}
}

function performClose(formObj) 
{   
	if (formObj) 
	{

		formObj.mode.value = 'display';

		formObj.submit();
      
	}
}


function xmlencode(string) {
    return string.replace(/\&/g,'&'+'amp;').replace(/\'/g,'&'+'apos;');
}
