/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */
dojo.provide("bux.dialogs.CalculationDialog");

dojo.require("bux.dialogs.BaseCustomContentDialog");
dojo.require("bux.layout.TableContainer");
dojo.require("dijit.form.NumberTextBox");
dojo.require("dijit.form.Button");
dojo.require("bux.Helper");
dojo.require("bux.i18n");

dojo.declare("viewer.dialogs.CalculationDialog", bux.dialogs.BaseCustomContentDialog, {
	sTitle: null,
	sLabel: null, /*String the lablel of the calculation  dialog*/
	sDescription: null,
	okHandler: null, /*Function?*/
	cancelHandler:null, /*Function?*/

	startup: function() {
		this.updateTitle(this.sTitle);
		this.inherited(arguments);
		var tableContainer = new bux.layout.TableContainer({
			// TODO remove this class
			classname: "bux-InformationDialog"
		},this.contentContainer);

		var cell = null, row = null;
		if (this.sDescription) {
			row = new bux.layout.TableContainerRow({
				parentContainer: tableContainer
			});
			cell = new bux.layout.TableContainerCell({
				classname: "bux-dialog-info",
				parentContainer: row
			});
			cell.addContent(document.createTextNode(this.sDescription));
		}

		row = new bux.layout.TableContainerRow({
			parentContainer: tableContainer
		});
		cell = new bux.layout.TableContainerCell({
			classname: "bux-dialog-label",
			parentContainer: row
		});

		this._calculationField = new dijit.form.NumberTextBox({required:true});
		var _label = document.createElement("label");
		_label.appendChild(document.createTextNode(this.sLabel));
		_label.setAttribute("for", this._calculationField.id);
		cell.addContent(_label);

		row = new bux.layout.TableContainerRow({
			parentContainer: tableContainer
		});

		cell = new bux.layout.TableContainerCell({
			classname: "bux-dialog-field",
			parentContainer: row
		});
		cell.addContent(this._calculationField.domNode);
	},
	onOK : function()
	{
		if (this._calculationField.state != "Error")
		{
			this.inherited(arguments);
			this.okHandler(this._calculationField.attr("value"));
			this.hide();
		}
	}
});
