/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */
dojo.provide("bux.reportViewer.ReportInfo");
dojo.require("bux.Tooltip");

dojo.declare("bux.reportViewer.ReportInfo", bux.TooltipBase, {

	templateString: "<div class=\"dijitTooltip dijitTooltipLeft\" id=\"dojoTooltip\">\n\t<div class=\"dijitTooltipContainer dijitTooltipContents\" dojoAttachPoint=\"containerNode\" waiRole='alert'></div>\n\t<div class=\"dijitTooltipConnector\"></div>\n</div>\n",

	title: "",
	text: "",
	linkText: null,
	link: null,

	createMarkup: function() {
		var linkId = this.connectId + "_linkId";

		var content = "";
		content +=		"<table role=\"presentation\" class=\"bux-tooltip-table\" cellspacing=\"0\" cellpadding=\"0\">";
		content +=			"<tr>";
		content +=				"<td class=\"bux-tooltip-title\">";
		content +=					html_encode(this.title);
		content +=			"</td>";
		content +=			"</tr>";
		content +=			"<tr>";
		content +=				"<td class=\"bux-tooltip-text\">";
		content +=					html_encode(this.text);
		content +=			"</td>";
		content +=			"</tr>";
		content +=			"<tr>";

		if( this.link )
		{
			content +=			"<td class=\"bux-tooltip-text\">";
			content +=				'<a role=\"link\" id="' + linkId + '" href="#">' + html_encode(this.linkText) + '</a>';
			content +=			"</td>";
		}
		else
		{
			content +=			"<td></td>";
		}

		content +=			"</tr>";
		content +=		"</table>";

		if ( this.link ) {
			setTimeout(dojo.hitch(this, function(){
				var _tDom = dojo.byId(linkId);
				if (_tDom !== null) {
					_tDom.onclick = this.link ;
				}
			}), 1);
		}

		return content;
	}


});