/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */

dojo.provide("ViewerIWidgetDialogButton");

/**
 * Class that will take care of showing an inline dialog centered in the widget.
 * @param {Object} oCV
 * @param {Object} sHTML
 */
dojo.declare("ViewerIWidgetDialogButton", null, {
	constructor: function(sOnClick, sLabel) {
		this.m_sOnClick = sOnClick;
		this.m_sLabel = sLabel;
	},

	render: function() {
		return "<span onclick=\"" + html_encode(this.m_sOnClick) + "\" onmouseover=\"this.className = 'dijit dijitReset dijitLeft dijitInline dijitButton dijitHover dijitButtonHover';\" onmouseout=\"this.className = 'dijit dijitReset dijitLeft dijitInline dijitButton';\" class=\"dijit dijitReset dijitLeft dijitInline dijitButton\">" +
					"<span class=\"dijitReset dijitRight dijitInline\">" +
						"<span class=\"dijitReset dijitInline dijitButtonNode\">" +
							"<button title=\"\" type=\"button\" name=\"\" class=\"dijitReset dijitStretch dijitButtonContents\" role=\"button\" tabindex=\"0\" style=\"background-color: transparent; -moz-user-select: none;\">" +
								"<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" role=\"presentation\">" +
									"<tbody>" +
										"<tr>" +
											"<td class=\"bux-baseDialog-Button-left\">" +
												"<div style=\"width: inherit;\"></div>" +
											"</td>" +
											"<td class=\"dijitButtonText bux-baseDialog-Button-center\">" +
												"<span class=\"dijitReset dijitInline\">" +
													"<span class=\"dijitReset dijitToggleButtonIconChar\"></span>" +
												"</span>" +
												"<span class=\"dijitStretch\">" + html_encode(this.m_sLabel) + "</span>" +
											"</td>" +
											"<td class=\"bux-baseDialog-Button-right\">" +
												"<div style=\"width: inherit;\"></div>" +
											"</td>" +
										"</tr>" +
									"</tbody>" +
								"</table>" +
							"</button>" +
						"</span>" +
					"</span>" +
				"</span>";
	}
});