/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */

 dojo.provide("ViewerIWidgetGlobalPromptErrorPage");
 dojo.require("IWidgetErrorPage");

 dojo.declare("ViewerIWidgetGlobalPromptErrorPage", IWidgetErrorPage, {
	m_sendRequestOnOK: false,
	setSendRequestOnOK: function( bSendRequestOnOK )
	{
		this.m_sendRequestOnOK = bSendRequestOnOK;
	},

	retry: function() {
		this.clear();
		this.m_oCV.executeAction("RetryRequest", this.m_oCV["LAST_ACTION_PARAMS"]);
	},

	ok: function() {
		this.clear();
		this.m_oCV.getViewerWidget().disableListenToForGlobalPrompt();

		// for certain errors, we need to submit a request on OK see bug 2711145
		if( this.m_sendRequestOnOK )
		{
			var lastActionFormFields = this.m_oCV["LAST_ACTION_PARAMS"].param1.getFormFields();
			if( lastActionFormFields.exists( "widget.globalPromptInfo"))
			{
				delete lastActionFormFields.m_aValues["widget.globalPromptInfo"];
			}
			this.m_oCV.executeAction("RetryRequest", this.m_oCV["LAST_ACTION_PARAMS"]);
		}
	},

	clear: function() {
		this.m_dlg.destroy();
		this.m_oCV.getViewerWidget().setErrorDlg(null);
	}
 });