/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */


dojo.provide("ViewerIWidgetWaitPage");

dojo.declare("ViewerIWidgetWaitPage", CCommonWaitPage, {

	constructor: function(sNamespace, sGateway) {
		this.m_sNamespace = sNamespace;

		this.m_sGateway = sGateway;
		this.m_cancelCallback = null;

		try {
			if (this.getCognosViewer() == null) {
				var oCV = eval ('oCV' + sNamespace);
				this.setCognosViewer(oCV);
			}

			this.m_waitPageDialog = new ViewerIWidgetInlineDialog(this.getCognosViewer(), this.getWaitPageHTML());

			// uncomment to help debug the wait dialog
			// this.m_waitPageDialog.setDebugHelper(getCognosViewerObjectRefAsString(this.getCognosViewer().getId()) + ".m_waitPage");
		}
		catch (e) {
			if (console && console.log) {
				console.log(e);
			}
		}
	},

	show: function(bSavedReport, cancelCallback) {
		if (this.getUseWaitPage() == true) {
			this.m_cancelCallback = cancelCallback;
			this.m_waitPageDialog.show();
		}
	},

	getWaitPageHTML: function() {
		var cancelButton = new ViewerIWidgetDialogButton(getCognosViewerObjectRefAsString(this.getCognosViewer().getId()) + ".m_waitPage.doCancel();", RV_RES.CANCEL);
		var id = this.getCognosViewer().getId();
		return '<table cellspacing="4" cellpadding="0" border="0" wairole="region" role="region">' +
					'<tbody>' +
						'<tr>' +
							'<td align="center">' +
								'<div class="dijitInline widget_load" id="working' + id +'" aria-labelledby="working' + id + '" role="presentation" tabindex="0">' + RV_RES.IDS_JS_WAIT_PAGE_LOADING + '</div>' +
								'<div class="bux-basedialog-button-area" style="text-align:center;padding-left:12px;">'+
									cancelButton.render() +
								"</div>" +
							'</td>' +
						'</tr>' +
					'</tbody>' +
				'</table>';
	},

	hide: function() {
		this.m_waitPageDialog.hide();
		this.m_cancelCallback = null;
	},

	doCancel: function() {
		if(this.m_cancelCallback) {
			this.m_cancelCallback();
			this.m_cancelCallback = null;
		} else {
			var oCV = this.getCognosViewer();

			var bCancelCalled = oCV.cancel();


			if (oCV.isReportRenderingDone()) {
				this.hide();
			}
			else {
				var payload = { action: 'deleteWidget' };
				oCV.getViewerWidget().iContext.iEvents.fireEvent("com.ibm.bux.widget.action", null, payload);
			}

			oCV.hideExecutionCursor();

			// is we actually sent a cancel request, fix up the undo/redo stack
			if (bCancelCalled) {
				var undoRedoQueue = oCV.getViewerWidget().getUndoRedoQueue();
				if (undoRedoQueue) {
					undoRedoQueue.handleCancel();
				}
			}
		}

	},

	/**
	 * Methods that are called from CCognosViewer. Used for the stand alone Viewer.
	 */
	showSimpleWaitDialog: function() {},
	initializeWaitPage: function(sHTML) {},
	destroy: function() {}
});