/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */

function ActionFactory(cognosViewer)
{
	this.m_cognosViewer = cognosViewer;
	this.m_actionCache = {};
}

ActionFactory.prototype.load = function(sAction)
{
	var action = null;
	try
	{
		if (this.m_actionCache[sAction]) {
			action = this.m_actionCache[sAction];
		} else {
			var sClass = sAction + "Action";
			action = eval("(typeof "+ sClass + "=='function'? new " + sClass + "():null);");
			if (action) {
				action.setCognosViewer(this.m_cognosViewer);
			}
			this.m_actionCache[sAction] = action;
		}
	}
	catch(exception)
	{
		action = null;
	}

	return action;
};

function ActionFactory_loadActionHandler(evt, cognosViewer)
{
	var ctxNode = getCtxNodeFromEvent(evt);
	var selectionController = cognosViewer.getSelectionController();

	var action = null;

	if(ctxNode !== null)
	{
		var ctxValue = ctxNode.getAttribute("ctx");
		ctxValue = ctxValue.split("::")[0].split(":")[0];

		var descriptionNode = ctxNode.getAttribute("type") != null ? ctxNode : ctxNode.parentNode;
		var type = descriptionNode.getAttribute("type");

		switch(type)
		{
			case "columnTitle":
				if(descriptionNode.getAttribute("CTNM") != null && selectionController.getMun(ctxValue) != "")
				{
					action = new DrillUpDownAction();
					action.updateDrillability(cognosViewer, ctxNode);
				}
				else
				{
					action = new RenameDataItemAction();
				}
				break;
			case "datavalue":
			case "chartElement":
			case "ordinalAxisLabel":
			case "legendLabel":
			case "legendTitle":
			case "ordinalAxisTitle":
				if(selectionController.getMun(ctxValue) != "")
				{
					action = new DrillUpDownAction();
					action.updateDrillability(cognosViewer, ctxNode);
				}
				break;
		}
	}

	if(action === null)
	{
		action = new SelectionAction();
	}

	action.setCognosViewer(cognosViewer);

	return action;
}