/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */

// Helper class which takes of of dynamic loading of menus
function LoadMenuAction()
{
	this.m_action = null;
}

LoadMenuAction.prototype = new CognosViewerAction();


LoadMenuAction.prototype.setRequestParms = function(payload)
{
	this.m_action = payload.action;
};

LoadMenuAction.prototype.execute = function()
{
	var actionFactory = this.m_oCV.getActionFactory();
	var action = actionFactory.load(this.m_action);

	var toolbarItem = this.getRootMenuItem();
	var buildMenuCallback = GUtil.generateCallback(this.buildMenuCallback, [toolbarItem], this);
	toolbarItem = action.buildMenu(toolbarItem, buildMenuCallback);
	if(toolbarItem != null)
	{
		this.buildMenuCallback(toolbarItem);
	}
};

LoadMenuAction.prototype.buildMenuCallback = function(toolbarItem)
{
	toolbarItem.open = true;
	toolbarItem.action = null;
	this.m_oCV.getViewerWidget().fireEvent("com.ibm.bux.widgetchrome.toolbar.update", null, [toolbarItem]);
};

LoadMenuAction.prototype.getRootMenuItem = function()
{
	var toolbarPayload = this.m_oCV.buxToolbarPayload;
	for(var toolbarItem = 0; toolbarItem < toolbarPayload.length; ++toolbarItem) {
		var name = toolbarPayload[toolbarItem]["name"];
		if (typeof name != "undefined" && name == this.m_action)
		{
			return toolbarPayload[toolbarItem];
		}
	}
};