/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */

function UndoRedoAction(){}
UndoRedoAction.prototype = new CognosViewerAction();

UndoRedoAction.prototype.sendRequest = function(filters, action)
{
	var cognosViewerRequest = null;
	var undoObj = null;

	if (action == "Undo")
	{
		undoObj = this.getUndoRedoQueue().moveBack();
	}
	else
	{
		undoObj = this.getUndoRedoQueue().moveForward();
	}

	var widgetProperties = this.getCognosViewer().getViewerWidget().getProperties();

	if (widgetProperties && undoObj.widgetProperties)
	{
		widgetProperties.doUndo(undoObj.widgetProperties);
	}

	if (typeof undoObj.spec != "undefined")
	{
		cognosViewerRequest = new CCognosViewerRequest("runSpecification");
		cognosViewerRequest.addParameter("ui.spec", undoObj.spec);
		cognosViewerRequest.addParameter("executionParameters", undoObj.parameters);
	}
	else
	{
		cognosViewerRequest = new CCognosViewerRequest("undoRedo");
		cognosViewerRequest.addParameter("ui.conversation", undoObj.conversation);
	}

	if (typeof undoObj.hasAVSChart != "undefined")
	{
		cognosViewerRequest.addParameter("hasAVSChart", undoObj.hasAVSChart);
	}

	if (widgetProperties && widgetProperties.getRowsPerPage() != null) {
		cognosViewerRequest.addParameter( "run.verticalElements", widgetProperties.getRowsPerPage() );
	}

	if(filters != "")
	{
		cognosViewerRequest.addParameter("cv.updateDataFilters", filters);
	}

	if (typeof undoObj.infoBar == "string")
	{
		cognosViewerRequest.addParameter("rap.reportInfo", undoObj.infoBar);
	}
	else
	{
		cognosViewerRequest.addParameter("rap.reportInfo", "{}");
	}

	cognosViewerRequest.addParameter("run.prompt", "false");

	this.getCognosViewer().sendRequest(cognosViewerRequest);

	this.fireModifiedReportEvent();
};

UndoRedoAction.prototype.execute = function()
{
	this.gatherFilterInfoBeforeAction(this.m_sAction);
};
