/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */

function ViewAllSnapshotsAction(){}
ViewAllSnapshotsAction.prototype = new CognosViewerAction();

ViewAllSnapshotsAction.prototype.execute = function() {
	var cognosViewerObjectString = getCognosViewerObjectString(this.m_oCV.getId());

	var menuItemString = RV_RES.IDS_JS_SELECT_SNAPSHOT_DIALOG_TITLE;
	var enterNumberLabel = RV_RES.IDS_JS_SELECT_SNAPSHOT_DIALOG_DESC;
	var cmResponse = this.getCognosViewer().getViewerWidget().getSavedOutputsCMResponse();
	var creationTime = this.getCognosViewer().envParams["creationTime"];

	this.selectSnapshotDialog = new viewer.dialogs.SelectSnapshot({
		sTitle:menuItemString,
		sLabel:enterNumberLabel,
		cmResponse:cmResponse,
		currentSnapshotCreationTime: creationTime,
		okHandler: function(sStoreID, sCreationTime)
		{
			window[cognosViewerObjectString].executeAction("ViewSavedOutput", {obj:sStoreID, creationTime: sCreationTime});
		},
		cancelHandler: function() {}
	});
	this.selectSnapshotDialog.startup();
	this.selectSnapshotDialog.show();
};
