/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */

cvLoadDialog = function(oCognosViewerObject, aFormFields, width, height, sIframeTitle)
{
	var formWarpRequest = document.getElementById("formWarpRequest" + oCognosViewerObject.getId());

	if(formWarpRequest && oCognosViewerObject)
	{
		oCognosViewerObject.showWaitPage(false);

		var target = "";
		var sPath = "";
		var modalDialog = null;

		if (oCognosViewerObject.isAccessibleMode())
		{
			target = "winNAT_" + ( new Date() ).getTime();
			sPath = oCognosViewerObject.getWebContentRoot() + "/" + "rv/blankNewWin.html?cv.id=" + this.getCVId();
		}
		else
		{
			var parent = document.body;
			if (document.getElementById("liveAriaSpan"))
			{
				parent = document.getElementById("liveAriaSpan");
			}

			modalDialog = new CModal("", "", parent, null, null, height, width, true, true, false, true, oCognosViewerObject.getWebContentRoot());

			if (typeof sIframeTitle == "string")
			{
				document.getElementById(CMODAL_CONTENT_ID).setAttribute("title", sIframeTitle);
			}
			document.getElementById(CMODAL_BACK_IFRAME_ID).setAttribute("title", RV_RES.IDS_JS_MODAL_BACK_IFRAME);

			target = CMODAL_CONTENT_ID;
		}

		var dialogForm = document.createElement("FORM");
		dialogForm.method = "POST";
		dialogForm.action = oCognosViewerObject.getGateway();
		dialogForm.target = target;
		dialogForm.style.margin = "0px";

		document.body.appendChild(dialogForm);

		for(var formFieldName in aFormFields)
		{
			dialogForm.appendChild(createHiddenFormField(formFieldName, aFormFields[formFieldName]));
		}

		dialogForm.appendChild(createHiddenFormField("cv.id", oCognosViewerObject.getId()));
		dialogForm.appendChild(createHiddenFormField("b_action", "xts.run"));

		dialogForm.appendChild(createHiddenFormField("ui.action", formWarpRequest["ui.action"].value));
		dialogForm.appendChild(createHiddenFormField("ui.object", formWarpRequest["ui.object"].value));

		if(typeof oCognosViewerObject.rvMainWnd != "undefined")
		{
			dialogForm.appendChild(createHiddenFormField("run.outputFormat", oCognosViewerObject.rvMainWnd.getCurrentFormat()));
		}

		if(typeof formWarpRequest["run.outputLocale"] != "undefined")
		{
			dialogForm.appendChild(createHiddenFormField("run.outputLocale", formWarpRequest["run.outputLocale"].value));
		}

		if(typeof dialogForm["backURL"] == "undefined" && typeof dialogForm["ui.backURL"] == "undefined" && typeof formWarpRequest["ui.backURL"] != "undefined")
		{
			dialogForm.appendChild(createHiddenFormField("ui.backURL", formWarpRequest["ui.backURL"].value));
		}

		if(typeof oCognosViewerObject != "undefined" && typeof oCognosViewerObject.getConversation != "undefined" && typeof oCognosViewerObject.getTracking != "undefined")
		{
			dialogForm.appendChild(createHiddenFormField("ui.conversation", oCognosViewerObject.getConversation()));
			dialogForm.appendChild(createHiddenFormField("m_tracking", oCognosViewerObject.getTracking()));

			if(oCognosViewerObject.envParams["ui.name"] != "undefined")
			{
				dialogForm.appendChild(createHiddenFormField("ui.name", oCognosViewerObject.envParams["ui.name"]));
			}
		}

		// Remove onBeforeUnLoad for this submission but set it back after.
		var oldUnload = window.onbeforeunload;
		window.onbeforeunload = null;

		if (oCognosViewerObject.isAccessibleMode())
		{
			window.open(sPath, target, "rv");
			dialogForm.submit();
		}
		else
		{
			// Submit the form
			dialogForm.submit();
			modalDialog.show();
		}

		window.onbeforeunload = oldUnload;

		document.body.removeChild(dialogForm);

		oCognosViewerObject.modalShown = true;
	}
};

function createHiddenFormField(name, value)
{
	var formField = document.createElement("input");
	formField.setAttribute("type", "hidden");
	formField.setAttribute("name", name);
	formField.setAttribute("id", name);
	formField.setAttribute("value", value);
	return(formField);
}

function isAuthenticationFault(soapFaultDocument)
{
	if(soapFaultDocument != null) {
		var camElement = XMLHelper_FindChildByTagName(soapFaultDocument, "CAM", true);
		return (camElement != null && XMLHelper_FindChildByTagName(camElement, "promptInfo", true) != null);
	}
}

/*
 * Checks the response for an authentication fault. If it finds one it will launch the log on dialog
 * Returns true if an authentication fault was detected
 */
function processAuthenticationFault(soapFaultDocument, cognosViewerID)
{
	if (isAuthenticationFault( soapFaultDocument) )
	{
		if (typeof g_firefoxPluginHelper != "undefined" && g_firefoxPluginHelper != null)
		{
			g_firefoxPluginHelper.addDebugLogsFromResponseXML(soapFaultDocument);
		}

		launchLogOnDialog(cognosViewerID, soapFaultDocument );
		return true;
	}


	return false;
}

/*
 * Calls close.xts which end up showing the log on dialog
 */
function launchLogOnDialog(cvID, response)
{
	try
	{
		var oCV = getCognosViewerObjectRef(cvID);
		var params = {
			"b_action":"xts.run",
			"m":"portal/close.xts",
			"h_CAM_action" : "logonAs"};

		if (response != null)
		{
			var namespaceNodes = XMLHelper_FindChildrenByTagName(response, "namespace", true);
			if (namespaceNodes != null)
			{
				for(var index = 0; index < namespaceNodes.length; ++index)
				{
					var namespaceNode = namespaceNodes[index];
					if (namespaceNode != null)
					{
						var namespaceNameNode = XMLHelper_FindChildByTagName(namespaceNode, "name", false);
						var namespaceValueNode = XMLHelper_FindChildByTagName(namespaceNode, "value", false);
						if (namespaceNameNode != null && namespaceValueNode != null)
						{
							var namespaceName = XMLHelper_GetText(namespaceNameNode);
							var namespaceValue = XMLHelper_GetText(namespaceValueNode);
							if (namespaceName != null && namespaceName.length > 0)
							{
								params[namespaceName] = namespaceValue;
							}
						}
					}
				}
			}
		}

		cvLoadDialog(oCV, params, 540, 360);
	}
	catch(exception)
	{
	}
}

/*
 * Goes through the array of cognos viewer objects to find the one with a LAST_ACTION set
 */
function getCVWaitingOnFault()
{
	// need to find our oCV object
	var oCV = null;
	for (var iIndex=0; iIndex < window.gaRV_INSTANCES.length; iIndex++)
	{
		// if the oCV object has a non-empty LAST_ACTION then is must
		// be the one that triggered the log on
		if (typeof window.gaRV_INSTANCES[iIndex]["LAST_ACTION"] != "undefined" && window.gaRV_INSTANCES[iIndex]["LAST_ACTION"] != "")
		{
			oCV = window.gaRV_INSTANCES[iIndex];
			break;
		}
	}

	return oCV;
}

/*
 * Set all the cognos viewer LAST_ACTION to empty (unless a viewer instance is passed in, then only that viewer's instance will be cleared)
 */
function clearLastAction(viewerInstance)
{
	if(typeof viewerInstance != "undefined" && viewerInstance != null)
	{
		clearLastViewerAction(viewerInstance);
	}
	else
	{
		for (var iIndex=0; iIndex < window.gaRV_INSTANCES.length; iIndex++)
		{
			clearLastViewerAction(window.gaRV_INSTANCES[iIndex]);
		}
	}
}

/*
 * Clears the last action for the specificed viewer instance
 */
function clearLastViewerAction(viewerInstance)
{
	if (typeof viewerInstance["LAST_ACTION"] != "undefined")
	{
		viewerInstance["LAST_ACTION"] = "";
	}

	if (typeof viewerInstance["LAST_ACTION_PARAMS"] != "undefined")
	{
		viewerInstance["LAST_ACTION_PARAMS"] = "";
	}
}


/*
 * Callback used from the logon dialog
 */
function ccModalCallBack(command, data)
{
	var oCV = getCVWaitingOnFault();
	destroyCModal();

	if (oCV != null)
	{
		if (typeof command != "undefined" && command == "ok")
		{
			if (oCV.getRV() != null)
			{
				oCV.getRV().updateUserName();
			}

			if (oCV["LAST_ACTION"] == "getAvailableOutput")
			{
				oCV.getRV().getAvailableOutput();
			}
			else if (oCV["LAST_ACTION"] == "SubscriptionManager")
			{
				var actionParams = oCV["LAST_ACTION_PARAMS"];
				oCV.getSubscriptionManager().AJAXHelper(actionParams.param1, actionParams.param2, actionParams.param3, actionParams.param4, actionParams.param5);
			}
			else if (oCV["LAST_ACTION"] == "getContextData")
			{
				oCV.getSelectionController().getCCDManager().FetchContextData(oCV["LAST_ACTION_PARAMS"].param1);
			}
			else if (oCV["LAST_ACTION"] == "sendRequest")
			{
				oCV.getWaitPageImpl().hide();
				var oRequest = oCV["LAST_ACTION_PARAMS"].param1;
				if (oRequest != null && oRequest.getAction() == 'wait' && oCV.getRV() != null)
				{
					oCV.getRV().RunReport();
				}
				else
				{
					oCV.sendRequest(oRequest);
				}
			}
		}
		else
		{
			oCV.rvMainWnd.hideOpenMenus();
		}
	}
}

/*
 * Callback when the user hits the cancel button in a fault dialog
 */
function closeErrorPage()
{
	var oCV = getCVWaitingOnFault();
	destroyCModal();
	clearLastAction();
	if (oCV != null)
	{
		oCV.rvMainWnd.hideOpenMenus();
	}
}

function getNodeFromEvent(evt, bReturnImageNode)
{
	var node = null;
	if (document.all) {
		node = evt.srcElement;
	}
	else
	{
		node = evt.explicitOriginalTarget ? evt.explicitOriginalTarget : evt.originalTarget;
	}

	if (node && typeof node.getAttribute == "function" && node.getAttribute("name") == "primarySelectionDiv") {
		node = node.parentNode.firstChild;
	}

	if (node && typeof node.getAttribute == "function" && node.getAttribute("flashChartContainer") == "true") {
		node = node.firstChild;
	}

	// if the event was from the chart container, go find the image tag within the span.
	if (node && typeof node.getAttribute == "function" && node.getAttribute("chartContainer") == "true" && node.childNodes) {
		for (var i=0; i < node.childNodes.length; i ++) {
			if (node.childNodes[i].nodeName.toLowerCase() == "img") {
				node = node.childNodes[i];
				break;
			}
		}
	}
	// if the event was from an image which isn't a chart, get the parent
	else if (!bReturnImageNode && node && node.nodeName && node.nodeName.toLowerCase() == "img" && node.getAttribute("rsvpChart") != "true")
	{
		node = node.parentNode;
	}

	return node;
}

function getCtxNodeFromEvent(evt)
{
	try
	{
		var node = null;
		if (document.all) {
			node = evt.srcElement;
		}
		else
		{
			node = evt.originalTarget;
		}

		while (node.nodeType == 3) { // test to see if this is a text node
			node = node.parentNode;
		}

		var sNAME = node.nodeName.toUpperCase();
		if((sNAME == "SPAN" || sNAME == 'AREA' || sNAME == 'IMG') && node.getAttribute("ctx") != null)
		{
			return node;
		}
		else if (sNAME == "SPAN" && (node.parentNode.getAttribute("ctx") != null))
		{
			return node.parentNode;
		}
	}
	catch(exception){}

	return null;
}

function getDocumentFromEvent(evt)
{
	var node = null;
	var nodeDocument = null;
	if (document.all)
	{
		node = evt.srcElement;
		nodeDocument = node.document;
	}
	else
	{
		node = evt.explicitOriginalTarget ? evt.explicitOriginalTarget : evt.originalTarget;
		nodeDocument = node.ownerDocument;
	}

	return nodeDocument;
}

function stopEventBubble(evt)
{
	evt.returnValue = false;
	evt.cancelBubble = true;
	if(typeof evt.stopPropagation != "undefined")
	{
		evt.stopPropagation();
	}
	if(typeof evt.preventDefault != "undefined")
	{
		evt.preventDefault();
	}

	return false;
}

function setNodeFocus(evt)
{
	//get the event in a cross-browser fashion
	evt = (evt) ? evt : ((event) ? event : null);

	// set the focus to child span
	var srcNode = evt.originalTarget ? evt.originalTarget : evt.srcElement;
	if (srcNode && srcNode.childNodes && srcNode.childNodes.length > 0 && srcNode.childNodes[0].className == "textItem")
	{
		srcNode.childNodes[0].focus();
	}
}

function html_encode(str)
{
	return str.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;");
}

//take an input string and convert it into
//xml friendly entity references
function xml_encode(sInputString)
{
	var sOutputString = "" + sInputString;

	if ((sOutputString == '0') || ((sInputString != null) && (sInputString != false)))
	{
		//&amp;
		sOutputString = sOutputString.replace(/&/g, "&amp;");
		//&lt;
		sOutputString = sOutputString.replace(/</g, "&lt;");
		//&gt;
		sOutputString = sOutputString.replace(/>/g, "&gt;");
		//&quot;
		sOutputString = sOutputString.replace(/"/g, "&quot;");
		//&apos;
		sOutputString = sOutputString.replace(/'/g, "&apos;");
	}

	else if (sInputString == null)
	{
		//return empty string if the value is null or false
		sOutputString = "";
	}

	return sOutputString;
}


//take an xml friendly string and convert it into
//a js friendly string
function xml_decodeParser(sAll, sGroup1)
{
	var sRetval = sAll;
	switch(sGroup1)
	{
		case 'amp': sRetval = '&'; break;
		case 'lt': sRetval = '<'; break;
		case 'gt': sRetval = '>'; break;
		case 'quot': sRetval = '"'; break;
		case 'apos': sRetval = "'"; break;
	}
	return sRetval;
}

function xml_decode(sInputString)
{
	var sOutputString = "" + sInputString;

	if ((sOutputString == '0') || ((sInputString != null) && (sInputString != false)))
	{
		sOutputString = sOutputString.replace(/&(amp|lt|gt|quot|apos);/g, xml_decodeParser);
	}
	else if (sInputString == null)
	{
		//return empty string if the value is null or false
		sOutputString = "";
	}

	return sOutputString;
}

//Take a string and convert it into a string that is good to use as attribute value in an xpath.
//E.g to construct a xpath to get child elements that have name attribute:
//var xpath = "//[@name=" + xpath_attr_encode(nameValue) + "]";
function xpath_attr_encode(sInputString)
{
	var sQuotedString = null;
	if (sInputString.indexOf("'") >= 0 && sInputString.indexOf('"') >= 0) {
		var aInputs = sInputString.split('"');
		sQuotedString = "concat(";
		for (var i = 0; i < aInputs.length; ++i) {
			if (i > 0) {
				sQuotedString += ",";
			}
			if (aInputs[i].length > 0) {
				sQuotedString += ('"' + aInputs[i] + '"');
			} else {
				sQuotedString += '\'"\'';
			}
		}

		sQuotedString += ")";
	} else if (sInputString.indexOf("'") >= 0) {
		sQuotedString = '"' + sInputString + '"';
	} else {
		sQuotedString = "'" + sInputString + "'";
	}
	return sQuotedString;

}

function getCognosViewerObjectString(sId)
{
	return "oCV" + sId;
}

function getCognosViewerObjectRefAsString(sId)
{
	return "window." + getCognosViewerObjectString(sId);
}

function getCognosViewerObjectRef(sId)
{
	return window[getCognosViewerObjectString(sId)];
}

function getCognosViewerSCObjectString(sId)
{
	return "oCVSC" + sId;
}

function getCognosViewerSCObjectRefAsString(sId)
{
	return "window." + getCognosViewerSCObjectString(sId);
}

function getCognosViewerSCObjectRef(sId)
{
	return window[getCognosViewerSCObjectString(sId)];
}


function cleanupGlobalObjects(sId) {
	cleanupVariable( getCognosViewerObjectString(sId) );
	cleanupVariable( getCognosViewerSCObjectString(sId) );
}

function cleanupVariable( sVariableName ) {
	if( typeof window[sVariableName] != "undefined" && window[sVariableName] ) {
		if (isIE()){
			//It seems like IE does not like "delete window[sVariableName];"
			//it throws an exception and complains that
			//	"Object doesn't support this action"
			//However, using eval seems to work
			eval( "delete " + sVariableName );
		} else {
			delete window[sVariableName];
		}
	}
}

function loadClass(sClass)
{
	try
	{
		var object = eval("new " + sClass + "();");
		return object;
	}
	catch(e)
	{
		return null;
	}
}

function getElementsByClassName(oElm, strTagName, strClassName)
{
	var arrElements = (strTagName == "*" && oElm.all)? oElm.all : oElm.getElementsByTagName(strTagName);
	var arrReturnElements = [];
	var oRegExp = new RegExp("(^|\\s)" + strClassName + "(\\s|$)");
	var eleLen = arrElements.length;
	for(var i=0; i<eleLen; i++)
	{
		var oElement = arrElements[i];
		if(oRegExp.test(oElement.className))
		{
			arrReturnElements.push(oElement);
		}
	}
	return arrReturnElements;
}


function getImmediateLayoutContainerId(node)
{
	var currentNode = node;
	while (currentNode != null)
	{
		if (currentNode.getAttribute("lid") != null)
		{
			return currentNode.getAttribute("lid");
		}
		currentNode = currentNode.parentNode;
	}
	return null;
}

function getChildElementsByAttribute(oElm, aTagNames, strAttributeName, strAttributeValue)
{
	return getDescendantElementsByAttribute(oElm, aTagNames, strAttributeName, strAttributeValue, true);
}

function getElementsByAttribute(oElm, aTagNames, strAttributeName, strAttributeValue, maxSize, expAttributeValue) {

	return getDescendantElementsByAttribute(oElm, aTagNames, strAttributeName, strAttributeValue, false, maxSize, expAttributeValue);
}


function getDescendantElementsByAttribute(oElm, aTagNames, strAttributeName, strAttributeValue, childOnly, maxSize, expAttributeValue) {
	var arrReturnElements = [];
	var oAttributeValue = null;
	if( typeof expAttributeValue === "undefined")
	{
		oAttributeValue = (typeof strAttributeValue != "undefined") ? new RegExp("(^|\\s)" + strAttributeValue + "(\\s|$)", "i"): null;
	}
	else
	{
		oAttributeValue = expAttributeValue;
	}

	if (typeof aTagNames == "string")
	{
		aTagNames = [aTagNames];
	}

	var tagLen = (oElm ? aTagNames.length : 0);
	for (var tagName=0; tagName < tagLen; tagName++)
	{
		var arrElements = null;
		if (childOnly)
		{
			if (aTagNames[tagName] == "*" && oElm.all)
			{
				arrElements = oElm.childNodes;
			}
			else
			{
				arrElements = [];
				var childNodes = oElm.childNodes;
				for (var i = 0; i < childNodes.length; ++i)
				{
					if (childNodes[i].nodeName.toLowerCase() == aTagNames[tagName].toLowerCase())
					{
						arrElements.push(childNodes[i]);
					}
				}
			}
		}
		else
		{
			arrElements = (aTagNames[tagName] == "*" && oElm.all) ? oElm.all : oElm.getElementsByTagName(aTagNames[tagName]);
		}
		var eleLen = arrElements.length;

		for (var idx = 0; idx < eleLen; idx++) {
			var oCurrent = arrElements[idx];
			var oAttribute = oCurrent.getAttribute && oCurrent.getAttribute(strAttributeName);

			if (typeof oAttribute == "string" && oAttribute.length > 0) {
				if (typeof strAttributeValue == "undefined" || (oAttributeValue && oAttributeValue.test(oAttribute))) {
					arrReturnElements.push(oCurrent);
					if (maxSize != -1 && arrReturnElements.length > maxSize) {
						return [];
					}
					else if (maxSize == 1 && arrReturnElements.length == 1) {
						return arrReturnElements;
					}
				}
			}
		}
	}

	return arrReturnElements;
}

function savedOutputDoneLoading(cvId, count) {

	var oCV = window["oCV" + cvId];
	var oWidget = (oCV && oCV.getViewerWidget ? oCV.getViewerWidget() : null);
	var savedOutput = (oWidget ? oWidget.getSavedOutput() : null);

	if ( savedOutput ) {
		savedOutput.outputDoneLoading();
	} else if (count < 5) {
		// if we can't find the viewer object after a few tries, give up so we don't go into an endless loop.
		// Something bad must of happened since the iframe is done loading and we can't find the
		// correct viewer object to show the saved output
		count++;
		var _tryAgain = function() {
			savedOutputDoneLoading(cvId, count);
		};
		setTimeout(_tryAgain, 100);
	}
}

/*
 * Copied from V5ReportEngine.xsl, so any fixes here must also be done there.
 */
function textAlignForFirefox() {
	var userAgent = navigator.userAgent.toLowerCase();
	if ( (userAgent.indexOf("mozilla") > -1 && userAgent.indexOf ("msie") < 0) || (userAgent.indexOf("firefox") > -1)) {
		var style = document.createElement ("style");
		style.setAttribute ("type", "text/css");

		var head = document.documentElement.getElementsByTagName ("head");

		if (head.length > 0) {
			head.item (0).appendChild(style);
		}

		if (document.styleSheets.length > 0) {
			style.sheet.insertRule ("*[style*='text-align: right']{ text-align:-moz-right !important; } ", 0);
			style.sheet.insertRule ("*[style*='text-align: center']{ text-align:-moz-center !important; } ", 0);
		}
	}
}

/*
 * Copied from V5HTML.xsl, so any fixes here must also be done there.
 */
function getNavVer()
{
	var temp;
	if (isIE()){
		temp=navigator.userAgent.split('MSIE');
		return parseFloat(temp[1]);
	} else {

		temp = navigator.userAgent.split('\/');
		return parseFloat(temp[temp.length - 1]);
	}
}

/*
 * Copied from V5HTML.xsl, so any fixes here must also be done there.
 */
function isIE()
{
	return (navigator.userAgent.indexOf('MSIE') != -1);
}

/*
 * Copied from V5HTML.xsl, so any fixes here must also be done there.
 */
function displayChart(imageName, imgSrc, useScale, isImage)
{
	if (isIE() && getNavVer() >= 5.5 && getNavVer() < 7.0) {
		var oImg = document.images[imageName];
		var strOldImg;
		if (imgSrc.length > 1){
			strOldImg = imgSrc;
		} else {
			strOldImg = oImg.src;
		}

		var imgURL = strOldImg;
		oImg.srcbackup = imgURL;



		strOldImg = strOldImg.replace(new RegExp(/%/g), "%25");
		// BUG: IE's display filter parser is broken and incorrectly sees any closing
		// brackets contained in an href as the end of a filter expression .. so we need to escape them
		strOldImg = strOldImg.replace(/\x28/g, "%28");
		strOldImg = strOldImg.replace(/\x29/g, "%29");

		var strSizing = useScale ? "scale" : "crop";
		if ( isImage ) {
				strSizing = "image";
		}

		oImg.src = '../ps/images/space.gif';
		oImg.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" + strOldImg + "',sizingMethod='" + strSizing + "');";

	} else {
		if (imgSrc.length > 1){
			document.images[imageName].src = imgSrc;
		}
	}
}

function isFlashChartNode(evt)
{
	var node = getNodeFromEvent(evt);
	if(node != null && typeof node.getAttribute == "function")
	{
		return node.getAttribute("flashChart") != null;
	}

	return false;
}

//TODO - this isn't really a common method, so it should be moved to a BUX specific area
function onFlashChartRightClick(evt)
{
	if (evt && evt.button && evt.button != 0 && isFlashChartNode(evt))
	{
		return onViewerChartFocus(evt);
	}
}

function onViewerChartFocus(evt)
{
	if (evt.stopPropagation) {evt.stopPropagation();}
	if (evt.preventDefault) {evt.preventDefault();}
	if (evt.preventCapture) {evt.preventCapture();}
	if (evt.preventBubble) {evt.preventBubble();}

	var node = getNodeFromEvent(evt);
	var viewerId = node.getAttribute("viewerId");

	// possible that the viewer is on the parent, try there
	if (!viewerId) {
		viewerId = node.parentNode.getAttribute("viewerId");
	}

	if (!viewerId) {
		return;
	}

	var selectionAction = new SelectionAction();
	selectionAction.setCognosViewer(window["oCV" + viewerId]);
	selectionAction.pageClicked(evt);
	return stopEventBubble(evt);
}

function clientToScreenCoords(domObject, offsetParent)
{
	var current = domObject;

	var coords = { topCoord:0, leftCoord:0 };

	while(current != null && current != offsetParent)
	{
		coords.topCoord += current.offsetTop; coords.leftCoord += current.offsetLeft;
		current = current.offsetParent;
	}

	return coords;
}

function getCurrentPosistionString(oCV, current, count)
{
	var positionString = RV_RES.IDS_JS_INFOBAR_ITEM_COUNT;
	var reParam0 = /\{0\}/;
	var reParam1 = /\{1\}/;
	positionString = positionString.replace(reParam0, current);
	positionString = " " + positionString.replace(reParam1, count) + " ";
	return positionString;
}

/*
 * Class for containing common static functions
 */

 function CViewerCommon()
 {
 }

CViewerCommon.openNewWindowOrTab = function( sURL, sWindowName )
{
	//Leave the third parameter unspecified so that the browser's settings to open in tab/window will take effect.
	return window.open( sURL, sWindowName );
};

function setWindowHref(url) {
	var oldUnload=window.onbeforeunload;
	window.onbeforeunload=null;
	window.location.href = url;
	window.onbeforeunload=oldUnload;
}

/**
 *	Replaces parameter place holders in the specified msg with the specified args.
 *	args can be a string or any array, otherwise, it is treated as string.
 *	for example, getMessage("param0 {0}", 'zero") will return "param0 zero".
 */
CViewerCommon.getMessage = function(msg, args)
{
	if (typeof args == "undefined")
	{
		return msg;
	}
	else if (typeof args == "string")
	{
		msg = msg.replace("{0}", args);
	}
	else if (args.length)
	{
		for (var i = 0; i < args.length; ++i)
		{
			msg = msg.replace("{" + i + "}", args[i]);
		}
	}
	else
	{
		msg = msg.replace("{0}", args);
	}

	return msg;
};
