/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */
 function ServerRequest(sNamespaceId)
{
	this.m_namespaceId = sNamespaceId;
	// do this if block for the jsunit tests where oCV will not actually exist
	if (sNamespaceId != "")
	{
		this.m_oDispatcher = eval(sNamespaceId);
	}
	else
	{
		this.m_oDispatcher = null;
	}
	this.m_aParams = {};
	this.m_request = null;
}

function ServerRequest_getNamespace()
{
	return this.m_namespaceId;
}

function ServerRequest_execute(bCancellingRequest)
{
	var sParams = "";
	for (var idxParam in this.m_aParams)
	{
		sParams += "&" + idxParam + "=" + this.m_aParams[idxParam];
	}

	var oCV = getCognosViewerObjectRef(this.m_namespaceId);
	var oCVFragment = oCV.m_viewerFragment;

	var transientUpdatedOccured = false;
	if(typeof this.m_aParams["cv.fragmentEvent"] == "undefined" && (this.m_aParams["ui.action"] == "forward" || this.m_aParams["ui.action"] == "back"))
	{
		sParams += "&cv.fragmentEvent=false";
		transientUpdatedOccured = oCVFragment.changePromptValues(this.m_aParams);
	}


	// to allow check in CCDataManager to determine if there is a pending response
	// if another request is sent wth one pending that causes rsvp to cancel
	// the prior one (if it has not yet answered the prior request) HS COGCQ00239130
	// there is no need to clear this flag new instance will be created.
	this.m_request = {};
	this.m_oDispatcher.retrieve(sParams);

	this.clearRequest();
}

function ServerRequest_cancel()
{
	/* placeholder for interface */
	return true;
}

function ServerRequest_addArgument(sArgumentId, sArgument)
{
	this.m_aParams[sArgumentId] = sArgument;
}

function ServerRequest_setRequestURL(sGateway)
{
	/* placeholder for interface */
}

function ServerRequest_setCallback(fCallback)
{
	/* placeholder for interface */
}

function ServerRequest_setAction(sAction)
{
	/* placeholder for interface */
}

function ServerRequest_clearRequest()
{
	this.m_aParams = null;
	this.m_aParams = {};
}

function ServerRequest_getUsePageRequest()
{
	return false;
}

function ServerRequest_generateRequestParams(oParams, envParams)
{
	if(typeof oParams != "undefined" && oParams != null)
	{
		if (typeof envParams != "undefined" && envParams != null)
		{
			for(var param in envParams)
			{
				if(typeof oParams[param] == "undefined" && param.indexOf("frag-") != 0 && param != "cv.fragmentEvent" && param != "cv.transientSpec" && param != "cv.actionState" && param != "globalViewerTransient")
				{
					oParams[param] = encodeURIComponent(envParams[param]);
				}
			}
		}

		oParams["cv.responseFormat"] = "fragment";
		oParams["cv.ignoreState"] = "true";
		oParams["cv.id"] = "_THIS_";
	}
}


function ServerRequest_setUsePageRequest(bUsePageRequest)
{
}

ServerRequest.prototype.setUsePageRequest = ServerRequest_setUsePageRequest;
ServerRequest.prototype.execute = ServerRequest_execute;
ServerRequest.prototype.getUsePageRequest = ServerRequest_getUsePageRequest;
ServerRequest.prototype.addArgument = ServerRequest_addArgument;
ServerRequest.prototype.setRequestURL = ServerRequest_setRequestURL;
ServerRequest.prototype.setCallback = ServerRequest_setCallback;
ServerRequest.prototype.setAction = ServerRequest_setAction;
ServerRequest.prototype.clearRequest = ServerRequest_clearRequest;
ServerRequest.prototype.generateRequestParams = ServerRequest_generateRequestParams;
ServerRequest.prototype.cancel = ServerRequest_cancel;
ServerRequest.prototype.getNamespace = ServerRequest_getNamespace;
