/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM
 *| IBM Cognos Products: Viewer
 *| (C) Copyright IBM Corp. 2001, 2010
 *|
 *| US Government Users Restricted Rights - Use, duplication or
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *|
 *+------------------------------------------------------------------------+
 */

//NEW DISPATCHER SUPPORT....


//DISPATCHER CLASS: (generic class).
function BuxDispatcher()
{
	this.m_activeRequest = null;
	this.m_requestQueue = [];
}

BuxDispatcher.prototype.dispatchRequest = function(dispatcherEntry)
{
	if (this.m_activeRequest==null) {
		this.startRequest(dispatcherEntry);
	} else if (dispatcherEntry.canBeQueued()==true) {
		this.m_requestQueue.push(dispatcherEntry);
	}
};

BuxDispatcher.prototype.startRequest = function(dispatcherEntry)
{
	this.m_activeRequest=dispatcherEntry;
	if (dispatcherEntry!=null) {
		dispatcherEntry.onStart();
		dispatcherEntry.m_asynchRequest.sendRequest();
	}
};

BuxDispatcher.prototype.requestComplete = function(dispatcherEntry)
{
	this.startRequest(this.nextRequest());
};

BuxDispatcher.prototype.nextRequest = function()
{
	//Get the next request to run:
	//If there are queued requests, check if its necessary to run them all.
	//NOTE: For now, just look at the duplicate requests at the head of the queue.
	var requestEntry=null;
	if (this.m_requestQueue.length>0) {
		requestEntry = this.m_requestQueue.shift();
		if (requestEntry.getKey() != null) {
			while(this.m_requestQueue.length > 0 &&
				  this.m_requestQueue[0].getKey() == requestEntry.getKey()) {
				requestEntry = this.m_requestQueue.shift();
			}
		}
	}
	return requestEntry;
};

BuxDispatcher.prototype.queueIsEmpty = function()
{
	return (this.m_requestQueue.length==0);
};
